package gridcomp.adl;

import java.io.File;

import gridcomp.Constants;
import gridcomp.controller.AutonomicController;
import gridcomp.controller.BeskeAttributeController;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.proactive.core.component.controller.MonitorController;

public class BeskeBuilder 
{
	public void setBeskeAttributes(Object component, String xmlFile) throws Exception
	{
		Component c = (Component)component;
		BeskeAttributeController fac = (BeskeAttributeController)c.getFcInterface(Constants.BESKE_ATTRIBUTE_CONTROLLER);
		AutonomicController     abc = (AutonomicController)c.getFcInterface(Constants.AUTONOMIC_CONTROLLER);
				
		abc.autonomicInit(null);
		fac.setXmlFile(new File(xmlFile));
	}
	
	public void activateMonitor(Object component)
	{
		try {
			Component c = (Component)component;
			MonitorController mcc;
			mcc = (MonitorController)c.getFcInterface(Constants.MONITOR_CONTROLLER);
			mcc.monitorInit();		
		} catch (NoSuchInterfaceException _) {
			// ignored
		}
		
	}
}
