package gridcomp.adl;

import java.io.File;
import java.util.Map;

import org.objectweb.fractal.adl.ADLException;
import org.objectweb.fractal.adl.AbstractLoader;
import org.objectweb.fractal.adl.Definition;
import org.objectweb.fractal.adl.Node;
import org.objectweb.fractal.adl.components.Component;
import org.objectweb.fractal.adl.components.ComponentContainer;

public class BeskeLoader extends AbstractLoader
{
	@SuppressWarnings("unchecked")
	public Definition load(String name, Map context) throws ADLException 
	{
		Definition d = clientLoader.load(name, context);
		checkNode(d);
		return d;
	}

	private void checkNode(Object node) throws ADLException
	{
		if (node instanceof BeskeContainer) {
			BeskeContainer container = (BeskeContainer)node;
			if (container.getBeske() != null) {
				Beske f = container.getBeske();
				if (f.getXmlFile() == null)
					throw new ADLException("XML behavioral skeleton descriptor missing", (Node)f);
				File xmlFile = new File(f.getXmlFile());
				if (!xmlFile.exists() || !xmlFile.isFile())
					throw new ADLException("The XML behavioral skeleton descriptor specified (" + f.getXmlFile() + ") does not exists or is not a file", (Node)f);
			}
		}
		
		if (node instanceof ComponentContainer) {
			Component[] comps = ((ComponentContainer)node).getComponents();
			for (Component c: comps)
				checkNode(c);
		}
	}
}
