package gridcomp.controller;

import java.io.File;
import java.util.Map;

import gridcomp.AutonomicException;

import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

public interface AutonomicController
{
    public static final String CONTROLLER_NAME = "autonomic-controller";

    public String[] listAutonomicOperations() throws AutonomicException;
    public GenericTypeWrapper<Object> execOperation(String op, Object... params) throws AutonomicException;

    // This is required to share information between abc actors (autonomic operations)
    public Map<String, Object> getKnowledge();
    // This is required to custom initialize the autonomic controller (behavioral skeleton)
    public void autonomicInit(File beske) throws Exception;
}
