package gridcomp.controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.proactive.core.ProActiveRuntimeException;
import org.objectweb.proactive.core.component.controller.AbstractProActiveController;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactoryImpl;

public class BeskeAttributeControllerImpl extends AbstractProActiveController implements BeskeAttributeController 
{
	private static final long serialVersionUID = 1L;
	
	private Properties prop = null;

	public BeskeAttributeControllerImpl(Component owner) 
	{
		super(owner);
	}

	@Override
	protected void setControllerItfType() 
	{
        try {
            setItfType(ProActiveTypeFactoryImpl.instance().createFcItfType(
                    BeskeAttributeController.CONTROLLER_NAME,
                    BeskeAttributeController.class.getName(),
                    TypeFactory.SERVER,
                    TypeFactory.OPTIONAL,
                    TypeFactory.SINGLE));
        } catch (InstantiationException e) {
            throw new ProActiveRuntimeException("Cannot create controller type: " + getClass().getName());
        }
	}

	public String getProperty(String key)
	{
		return prop.getProperty(key);
	}

	public void setXmlFile(File xmlFile) 
	{
		prop = new Properties();
		try {
			InputStream in = new FileInputStream(xmlFile);
			prop.load(in);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
