package gridcomp.operation;

import gridcomp.AutonomicException;
import gridcomp.controller.AutonomicController;

public abstract class AbstractAutonomicOperation implements AutonomicOperation
{
	protected AutonomicController owner = null;
    private boolean isContextChecked = false;
    public AbstractAutonomicOperation(AutonomicController ac)
    {
        this.owner = ac;
    }
    
    public Object execute(Object... params) throws AutonomicException 
    {
        if (!isContextChecked) {
            checkContext();
            isContextChecked = true;
        }
        
        return exec(params);
    }
   
    abstract protected void checkContext() throws AutonomicException;
    
    abstract protected Object exec(Object... params) throws AutonomicException;
    
}
