package org.objectweb.proactive.core.component.controller;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.proactive.api.PAActiveObject;
import org.objectweb.proactive.core.ProActiveRuntimeException;
import org.objectweb.proactive.core.body.request.Request;
import org.objectweb.proactive.core.body.request.RequestFilter;
import org.objectweb.proactive.core.component.Constants;

import org.objectweb.proactive.core.component.body.FComponentRequestFilter;
import org.objectweb.proactive.core.component.request.ComponentRequest;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactoryImpl;
import org.objectweb.proactive.core.util.wrapper.IntWrapper;

public class QueueControllerImpl extends AbstractProActiveController implements QueueController
{
	private static final long serialVersionUID = 8603407968494373804L;

	RequestFilter fRequestFilter = new FComponentRequestFilter();
    
    public QueueControllerImpl(Component owner)
    {
        super(owner);
    }

    @Override
    protected void setControllerItfType()
    {
        try {
            setItfType(ProActiveTypeFactoryImpl.instance().createFcItfType(Constants.REQUEST_QUEUE_CONTROLLER,
                       QueueController.class.getName(), TypeFactory.SERVER,
                       TypeFactory.MANDATORY, TypeFactory.SINGLE));
        } catch (InstantiationException e) {
            throw new ProActiveRuntimeException("cannot create controller " + this.getClass().getName());
        }
    }
    
    public IntWrapper getSize()
    {
        return new IntWrapper(getComponentFunctionalRequestSize());
        //return new IntWrapper(ProActive.getBodyOnThis().getRequestQueue().getRequestQueue().size());
    }

    public ComponentRequest popRequest()
    {
        return (ComponentRequest) PAActiveObject.getBodyOnThis().getRequestQueue().removeOldest(fRequestFilter);    
    }

    public void pushRequest(ComponentRequest r)
    {
        PAActiveObject.getBodyOnThis().getRequestQueue().add(r);
    }
    
    public List<ComponentRequest> popRequests(int n)
    {
        List<ComponentRequest> rem = new Vector<ComponentRequest>();
        int max = getComponentFunctionalRequestSize();
        for (int i = 0; i < n && i < max; i++) {
            ComponentRequest req = (ComponentRequest) PAActiveObject.getBodyOnThis().getRequestQueue().removeOldest(fRequestFilter);
            rem.add(req);
        }
        return rem;
    }
    
    public void pushRequests(List<ComponentRequest> rem)
    {
        for (ComponentRequest req: rem)
            PAActiveObject.getBodyOnThis().getRequestQueue().add(req);
    }
    
    private int getComponentFunctionalRequestSize()
    {
        // TODO: This is not good at all; every time recounting... maybe using add/remove listeners
        //       is better, but we need to find the right creation time...
        Request req;
        int counter = 0;
        Iterator<?> iter = PAActiveObject.getBodyOnThis().getRequestQueue().iterator();
        while (iter.hasNext()) {
            req = (Request)iter.next();            
            if (req instanceof ComponentRequest && !((ComponentRequest)req).isControllerRequest()) {
                counter++;
            }
        }
        return counter;
    }
}
