package gridcomp.map.controller;

import java.util.HashMap;
import java.util.Map;

import gridcomp.controller.AbstractAutonomicController;
import gridcomp.controller.AutonomicController;
//import gridcomp.operation.FarmAddWorker;
//import gridcomp.operation.FarmNumWorkers;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.proactive.core.ProActiveRuntimeException;
import org.objectweb.proactive.core.component.interception.InputInterceptor;
import org.objectweb.proactive.core.component.interception.OutputInterceptor;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactoryImpl;
import org.objectweb.proactive.core.mop.MethodCall;
import org.objectweb.proactive.core.util.wrapper.DoubleWrapper;

import gridcomp.map.controller.operation.*;

public class DPWorkerControllerImpl
	extends AbstractAutonomicController 
	implements  InputInterceptor, OutputInterceptor{
	
	private static final long serialVersionUID = 1L;
	Component owner;
	private Map executionTimes=null;
	
	public DPWorkerControllerImpl(Component arg0) {
		super(arg0);
		owner = arg0;
		executionTimes = new HashMap();
        addAutonomicOperation(GetWorkerStatus.OPNAME, new GetWorkerStatus(this));
        addAutonomicOperation(SetWorkerStatus.OPNAME, new SetWorkerStatus(this));
	}
	@Override
	protected void setControllerItfType() {
		try {
			setItfType(ProActiveTypeFactoryImpl.instance().createFcItfType(
			        AutonomicController.CONTROLLER_NAME,
			        AutonomicController.class.getName(),
			        TypeFactory.SERVER,
			        TypeFactory.OPTIONAL,
			        TypeFactory.SINGLE));
		} catch (InstantiationException e) {
			throw new ProActiveRuntimeException("Cannot create controller type: " + getClass().getName());
		}
	}
	public void afterInputMethodInvocation(MethodCall arg0) {
		// TODO Auto-generated method stub
		
	}
	public void beforeInputMethodInvocation(MethodCall arg0) {
		//System.out.println("DENTRO BEFORE=======================");
		executionTimes.put(arg0.getName(), new DoubleWrapper(System.currentTimeMillis()));
		
	}
	public void afterOutputMethodInvocation(MethodCall arg0) {
	//	System.out.println("DENTRO AFTER=======================");
		
		
	}
	public void beforeOutputMethodInvocation(MethodCall arg0) {
		DoubleWrapper dw = (DoubleWrapper)executionTimes.get(arg0);
		double diff = dw.doubleValue()-System.currentTimeMillis();
		executionTimes.put(arg0.getName(), new DoubleWrapper(diff));
	//	System.out.println("*********************Worker ha calcolato in "+diff);
	}
	

}
