package gridcomp.map.controller;

//import ibmusecase.additional.controller.MapRedistribute;
//import gridcomp.controller.AbstractAutonomicController;
//import java.lang.instrument.Instrumentation;
import java.util.List;

import gridcomp.map.controller.operation.*;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.proactive.core.component.interception.InputInterceptor;
import org.objectweb.proactive.core.component.interception.OutputInterceptor;
import org.objectweb.proactive.core.mop.MethodCall;

public class MapController extends AbstractAutonomicController
 implements  InputInterceptor, OutputInterceptor{
	private static final long serialVersionUID = 1L;
	public static final String MulticastInterfaceName = "multicastServerItf"; 
	private long weight;
	private double ServiceTime=0;
	private double LastServiceTimeMeasured=0;
	
	public MapController(Component owner) {
		super(owner);
		addAutonomicOperation(MapAddWorker.OPNAME, new MapAddWorker(this));
		addAutonomicOperation(MapSubWorker.OPNAME, new MapSubWorker(this));
		addAutonomicOperation(MapMonitor.OPNAME, new MapMonitor(this));
		addAutonomicOperation(GetServiceTime.OPNAME, new GetServiceTime(this));
		addAutonomicOperation(MapNumWorkers.OPNAME, new MapNumWorkers(this));
	}
	
	public void afterInputMethodInvocation(MethodCall arg0) {
		List lst = (List) arg0.getParameters()[0];
		int numworkers=0;
		if (lst.size()>1){
			try {
				numworkers = (((ContentController)owner.getFcInterface("content-controller")).getFcSubComponents()).length-1;
			} catch (NoSuchInterfaceException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			weight = lst.size()/numworkers;
			ServiceTime = System.currentTimeMillis();
		}
	}
	public double exportWeight(){
		return weight;
	}
	
	public double getServiceTime(){
		//returns the last service time measured
		return LastServiceTimeMeasured;
	}
	public void beforeInputMethodInvocation(MethodCall arg0) {}

	
	public void afterOutputMethodInvocation(MethodCall arg0) {
		LastServiceTimeMeasured = System.currentTimeMillis()-ServiceTime;
		
		// String model (where rate is :
		// #method:<observed method>#time:<ora attuale>#rate:<banda>#workers:5
	}

	public void beforeOutputMethodInvocation(MethodCall arg0) {}
	  
}
