package gridcomp.map.controller.operation;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
import org.objectweb.proactive.core.util.wrapper.DoubleWrapper;

import gridcomp.AutonomicException;
import gridcomp.controller.AutonomicController;
import gridcomp.controller.KnowledgeConstants;
import gridcomp.map.controller.MapController;
import gridcomp.operation.AbstractAutonomicOperation;

public class GetServiceTime extends AbstractAutonomicOperation {
	public static String OPNAME = "GetServiceTime";
	AutonomicController ac;
	public GetServiceTime(AutonomicController ac) {
		super(ac);
		this.ac = ac;
	}

	@Override
	protected void checkContext() throws AutonomicException {}

	@Override
	protected Object exec(Object... params) throws AutonomicException {
		//String observedMethod = (String) params[0];
		
		ProActiveComponent _owner = (ProActiveComponent) (owner.getKnowledge().get(KnowledgeConstants.PARENT));
		MapController mc=null;
		try {
			mc = (MapController) _owner.getFcInterface("autonomic-controller");
		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		double ret = (double)mc.getServiceTime();
		//System.out.println("Calcolato "+ret);
		return new DoubleWrapper(ret);
	}

}
