package gridcomp.map.controller.operation;

import gridcomp.AutonomicException;
import gridcomp.controller.AutonomicController;
import gridcomp.controller.KnowledgeConstants;
import gridcomp.operation.AbstractAutonomicOperation;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;

public class MapNumWorkers extends AbstractAutonomicOperation {
	public static String OPNAME = "MapNumWorkers";
	AutonomicController ac;
	
	public MapNumWorkers(AutonomicController ac) {
		super(ac);
		this.ac = ac;
	}

	@Override
	protected void checkContext() throws AutonomicException {}

	@Override
	protected Object exec(Object... params) throws AutonomicException {
		//String observedMethod = (String) params[0];
		int ret=0;
		ProActiveComponent _owner = (ProActiveComponent) (owner.getKnowledge().get(KnowledgeConstants.PARENT));
		ContentController cc;
		try {
			cc = (ContentController) _owner.getFcInterface("content-controller");
			ret = cc.getFcSubComponents().length-1;
		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//System.out.println("Calcolato "+ret);
		//return new GenericTypeWrapper(new Integer(ret));
		return new Integer(ret);
	}

}
