package gridcomp.map.controller.operation;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.control.IllegalContentException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.component.controller.MulticastController;
import org.objectweb.proactive.core.component.group.ProxyForComponentInterfaceGroup;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

//import doublemulticast.controller.MulticastControllerWithRedistribution;
import gridcomp.AutonomicException;
import gridcomp.controller.AutonomicController;
//import gridcomp.controller.ContextConstants;
import gridcomp.controller.KnowledgeConstants;
import gridcomp.operation.AbstractAutonomicOperation;
import gridcomp.map.controller.MapController;
import gridcomp.map.Partition;
import gridcomp.map.Task;

public class MapSubWorker  extends AbstractAutonomicOperation {
	
//	private static final Logger logger = Logger.getLogger(Loggers.OPERATION);
	public static String OPNAME = "MapSubWorker";
	
	public MapSubWorker(AutonomicController ac) {
		super(ac);
		
	}

	@Override
	protected void checkContext() throws AutonomicException {
    	if (owner.getKnowledge().get(KnowledgeConstants.PARENT) == null)
    		throw new AutonomicException("The component has not been set in context!");
	}

	@Override
	protected Object exec(Object... params) throws AutonomicException {
		

		System.out.println("\n========================================================================");
		System.out.println("                         [Start NF-MapSubWorker]                        ");
		System.out.println("========================================================================\n");
		//ProActiveComponent _owner = (ProActiveComponent) ctx.get(ContextConstants.PARENT);
	
		ProActiveComponent _owner = (ProActiveComponent) (owner.getKnowledge().get(KnowledgeConstants.PARENT));
		MulticastController mc=null;
		try {
			mc = (MulticastController) _owner.getFcInterface("multicast-controller");
			
		} catch (NoSuchInterfaceException e1) {
			e1.printStackTrace();
		}
		
		/*--------------------------------------- STOP THE COMPONENT -----------------------------*/
		LifeCycleController lcc=null;
		try {
			lcc = (LifeCycleController) _owner.getFcInterface(Constants.LIFECYCLE_CONTROLLER);
			((gridcomp.map.controller.LifeCycleControllerImpl)lcc).autonomicStopFc();
			//((dpskeleton.core.manager.impl.LifeCycleControllerImpl)lcc).autonomicStopFc();
		} catch (NoSuchInterfaceException e) {
			e.printStackTrace();
		}
	
		ContentController cc=null;
		try {
			cc = (ContentController) _owner.getFcInterface(Constants.CONTENT_CONTROLLER);
		} catch (NoSuchInterfaceException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		Component[] oldconfig = cc.getFcSubComponents();
		//Component worker = oldconfig[oldconfig.length-1];
		int posToRemove = selectRemoved(oldconfig);
		Component worker = oldconfig[posToRemove];
		 boolean reconf=false;
		 //AutonomicController ac=null;
		 try {
			worker.getFcInterface("autonomic-controller");
			reconf = true;
		} catch (NoSuchInterfaceException e) {}
	
		
		 if (reconf)
			 // Note: the oldconfig.leght refers to the oldconfiguration INCLUDING the 
			 // manager component!
			 //reconfigure(oldconfig, worker,ac);
			 reconfigure(oldconfig, cc,posToRemove,mc);
		 
		 else{
			System.out.println("\n[MapSubWorker] Stateless computation running, skip redistribution\n");
			try {
				_removeFromGroup(mc,worker);
				cc.removeFcSubComponent(worker);
				
			} catch (IllegalContentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalLifeCycleException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		 }
		 System.out.println("\n========================================================================");
		 System.out.println("                        [End NF-MapSubWorker]");
		 System.out.println("========================================================================\n");
		 
		// restart the application
		(((gridcomp.map.controller.LifeCycleControllerImpl)lcc)).autonomicStartFc();
		return null;
	}
	
	
private void _removeFromGroup(MulticastController mc, Component worker){
	/* mc: multicast controller
	 * worker: sub-component representing the worker we want to remove
	 * */
	
	ProActiveComponent _owner = (ProActiveComponent) (owner.getKnowledge().get(KnowledgeConstants.PARENT));
    
	Interface[] itf = (Interface[]) ((ProActiveComponent) _owner).getRepresentativeOnThis().getFcInterfaces();
	Interface[] wInterface =(Interface[]) ((ProActiveComponent)worker).getRepresentativeOnThis().getFcInterfaces();
	
	for (int i=0;i<itf.length;i++){
		// get the multicast interface name
		String itfname = itf[i].getFcItfName();
		
		 if  (itfname.startsWith(MapController.MulticastInterfaceName)){
			 // get a reference to the group
			 ProxyForComponentInterfaceGroup group = mc.lookupFcMulticast(itfname);
			 ProxyForComponentInterfaceGroup pfc = group.getDelegatee();
			 Iterator it  = pfc.iterator();	
			 // among all the interfaces bound to the multicast one...
			 
			 boolean trovato = false;
			 while(it.hasNext() && !(trovato)){
				Interface witf  = (Interface)  it.next();
			//	System.out.println("Analizzo interfaccia worker:");
			//	System.out.println(witf);
				// ... we have to find the one related to the worker selected to be removed
				for (int k=0;k<wInterface.length;k++)
					if (wInterface[k].equals(witf)){
			//			System.out.println(itfname+ " TROVATO!!!!!");
						pfc.remove(witf);
						System.out.println("[MapSubWorker] binding between "+witf.getFcItfName()+" and "+itfname+" just removed........");
						trovato = true;
						break;
					}
			 };
			 //pfc.remove(pos);
			 
		}
	  }
	
}	

private int selectRemoved(Component[] oldconfig){
	int i=0;
	int j=0;
	boolean trovato=false;
	while ((i<oldconfig.length)&&(!trovato)){
		Interface[] itf = (Interface[]) oldconfig[i].getFcInterfaces();
		j=0;
		while ((j<itf.length)&&(!trovato)){
			if (itf[j].getFcItfName().equals("reconfig"));
				trovato=true;
			j++;	
		}
		i++;
	}
	if (trovato)
		return i-1;
	else
		return -1;
	
}
private void reconfigure(Component[] oldconfig, ContentController cc, 
		int posToRemove, MulticastController mc) {
	 
	// Note: the oldconfig.leght refers to the oldconfiguration INCLUDING the 
	 // manager component!
	Object[] o = new Object[1];
	
	o[0]=new Integer(oldconfig.length-1);
	
	GenericTypeWrapper t = null;
	List<Object> collect = new ArrayList<Object>();

	// retrieve the current state of the workers
	System.out.println("\n============================================");
	System.out.println("   Redistribution of dataset: "+(oldconfig.length-1)+" -> "+(oldconfig.length-2)+" workers ");
	System.out.println("============================================\n");
	//int posToRemove=selectRemoved(oldconfig);
	
	/*
	 *  COLLECT
	 */ 
	//collects also the workers' controllers, excluding the manager component
	
	System.out.println("\n[MapSubWorker] COLLECT partitions from "+(oldconfig.length-1)+" workers ======\n");
	System.out.println("\n[MapSubWorker] Removing worker n. "+posToRemove);
	
	AutonomicController[] acAll = new AutonomicController[oldconfig.length-1];
	int p=0;
	for (int j=0;j<oldconfig.length;j++){
		try {
			acAll[p] = (AutonomicController) oldconfig[j].getFcInterface("autonomic-controller");
			// get the worker status as a List 
			t = (GenericTypeWrapper)acAll[p].execOperation("GetWorkerStatus",o);
			List partition = (List) t.getObject();
			if (partition!=null){
				// deep copy of the status and collapsing
				for (int i=0;i<partition.size();i++)
					collect.add((Task) partition.get(i));
			}	
			p++;
		} catch (NoSuchInterfaceException e) {
		}
	}
	// the new worker will be placed in the last position of acAll
	/*if (managerPos==oldconfig.length-1)
		posToRemove=oldconfig.length-2;
	else
		posToRemove = oldconfig.length-1;
		*/
	try {
		
		cc.removeFcSubComponent(oldconfig[posToRemove]);
		_removeFromGroup(mc,oldconfig[posToRemove]);
		oldconfig[posToRemove]=null;
		System.out.println("\n[MapSubWorker] worker n. "+posToRemove+" removed......");
		
	} catch (IllegalContentException e) {
		e.printStackTrace();
	} catch (IllegalLifeCycleException e) {
		e.printStackTrace();
		}
	
	if (collect.size()==0){
		System.out.println("\n[MapSubWorker] Stateless computation, no state to redistribute\n[MapSubWorker] Redistribution COMPLETED =======");
	}else{
		/*
		 * REDISTRIBUTION OF THE STATE
		 * */
		Task first = (Task)collect.get(0);
		Task last = (Task) collect.get(collect.size()-1);
		System.out.print("\n[MapSubWorker] SPLIT dataset ["+first.getObject()+"-"+last.getObject()+"] of "+collect.size()+" tasks into "+(acAll.length-1)+" partition\n");
		List<Object> lo = Partition.split(collect, acAll.length-1);
		Partition.showpartitions(lo);

		AutonomicController[] newac = new AutonomicController[acAll.length-1];
		int i=0;
		int j=0;
		while (j < acAll.length){
			if (j!=posToRemove){
				newac[i] = acAll[j];
				i++;
				j++;
			}else
				j++;
		}

				
		// distribute the new state to the workers
		System.out.println("\n[MapSubWorker] DISTRIBUTE "+collect.size()+" tasks to "+(acAll.length-1)+" workers ==\n"+lo.size());
		
		
		for (j=0;j<newac.length;j++){
			//System.out.println("Set "+j);
			newac[j].execOperation("SetWorkerStatus", lo.get(j));
		}
		
		System.out.println("\n============================================");
		System.out.println("         Redistribution COMPLETED             ");
		System.out.println("============================================\n");}
	}	 
}
