 package gridcomp.map.test.impl;
/*
 * - farm migliorato/ingegn.to
 * - map con un esempio che giri x mercoledi 16 aprile ore 15.00
 * */
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Random;
import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;import org.objectweb.fractal.util.Fractal;

import gridcomp.map.port.MulticastTestItf1;
import gridcomp.map.Task;

public class Test{
 	private static final long serialVersionUID = 1L;

	
    public static void main(String[] args) throws NoSuchInterfaceException, Exception {
    	
    	Properties programProperties = System.getProperties();
    	programProperties.setProperty("java.security.manager", new String());
        programProperties.setProperty("java.security.policy", "proactive.java.policy");
        programProperties.setProperty("fractal.provider", "org.objectweb.proactive.core.component.Fractive");
        programProperties.setProperty("log4j.configuration", "file:proactive-log4j");
        System.setProperties(programProperties);
        Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
        Map context = new HashMap();
        
        String actualtestcase = "";
        int p = 60;
      
        System.out.println("///////////////////////////////////////////////////////////");
        System.out.println(" Runnning on a dataset of "+p+" tasks......................");
        System.out.println("///////////////////////////////////////////////////////////");

        // testcase with no gathering interfaces 
       // context.put("worker", "doublemulticast.adl.server");
        actualtestcase = new String("gridcomp.map.test.adl.testcase");
        context.put("worker", "gridcomp.map.test.adl.worker");
        context.put("rulespath", "../GridComp-DataParallel/gridcomp/manager/map/adl/rules.drl");
         
        Component testcase = (Component) f.newComponent(actualtestcase,context);
        
        Fractal.getLifeCycleController(testcase).startFc();
        MulticastTestItf1 root1 = (MulticastTestItf1) testcase.getFcInterface("runTestItf-01");

        List<Task> ts = getParam(p,false);
        for (int i=0;i<100;i++){
        	root1.getService(ts);
        	Thread.sleep(2000);
            System.out.println("");
        }
        
        System.out.println("End of computation...........");
    }

	private static List<Task> getParam(int n, boolean broadcast){
    	List<Task> ts = new ArrayList<Task>();
    	Random rand = new Random();
    	int v = (Math.abs(rand.nextInt()))%n;
    	for (int i=0;i<n;i++){
    		if (broadcast)
    			ts.add(new Task(new Integer(v)));
   			else
  	   			ts.add(new Task(new Integer(i)));
    		    			
    	}  
    	return ts;	
    	
    }
}
