package gridcomp.map.test.impl;
import java.util.List;
import java.util.Vector;
import gridcomp.map.controller.operation.ReconfigSupport;
import gridcomp.map.Task;


public class TestWorker implements TestWorkerItf, ReconfigSupport{
    private static int IDgenerator=0;
    private int myid;
	private Vector<Task> mypiece=new Vector<Task>();	// e' un vector
	
	public TestWorker(){
		//super(owner);
		myid= IDgenerator++;
	}
	public synchronized Task getService(Task a) {
    	// questa e' una funzione di accumulazione/wrapper dei task
		mypiece.clear();
		if (a.isPrimitive()){
			Integer itg = (Integer)a.getObject();
			int v =  itg.intValue();
			mypiece.add(a);
			System.out.println("[WORKER-"+myid+"] Received PRIMITIVE entry: "+v);
		}else{
			// a contains a List implementation
	 		//System.out.println("[WORKER-"+myid+"] Receiving a partition of size "+a.size());
			
			List partition =  (List) a.getObject();

			for (int i=0;i<partition.size();i++){
	 			Task tt = (Task) partition.get(i);
	 			mypiece.add(tt);
			}
			System.out.print("[WORKER-"+myid+"] Working on partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]....\n");
	 	}
    	return null;
   	}
	
	public void printPiece(int s){
   		System.out.print("[WORKER-"+myid+"] Search task "+s+" in partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]\n");
   		/*
   		for (int i=0;i<mypiece.size();i++){
   			if (i<(mypiece.size()-1))
   				System.out.print((Integer)mypiece.get(i).getObject()+",");
   			else
   				System.out.print((Integer)mypiece.get(i).getObject());
   		}System.out.println("]");*/
	}
	public synchronized Task searchMatch(List<Task> tsl){
		/* The worker receives a List (of size 1) of Task (the fingerprint to look for)
		  */
		//System.out.println("[ServerImpl-"+myid+"] starts searching on "+tsl.size()+" values");
		Task ts = tsl.get(0);
		int s = ((Integer)ts.getObject()).intValue();
       	String res;
       	boolean found=false;
       	if (mypiece.size()==0){
       		System.out.println("[WORKER-"+myid+"] void status!");
       	}else{	
           	int i=0;
       		int v;
       		printPiece(s);
       		do{
       			v = ((Integer)((Task)mypiece.get(i)).getObject()).intValue();
       			if (s==v)
       				// match found!
       				found=true;
       			java.util.Random r = new java.util.Random();
       			double iteration=100000*(r.nextInt()%10);
       			double _sin=0,_ctg=0;
				double max=0;
       			for (int j=0;j<iteration;j++){
       				 _sin = Math.sin(iteration%r.nextInt());
       				_ctg = Math.cosh(iteration%r.nextInt());
       				if (max<Math.max(_sin, _ctg))
       						max = Math.max(_sin, _ctg);
       			}
       			i++;
       		}while(i<mypiece.size() && !found);
       	}
       	if (found){
       		res = "[WORKER-"+myid+"]-OK";
       	}else
       		res = "[WORKER-"+myid+"]-KO";
       	return new Task(res);
	}
	
	public void setStatus(List<Task> tsl){
		 // the status has been modified
		System.out.println("[WORKER-"+myid+"] updating the state from the controller....");
		
		mypiece.clear();
		for (int i=0;i<tsl.size();i++){
			mypiece.add(tsl.get(i));
		}
	//	System.out.println("[ServerImpl]-"+myid+"]  end setting a new state  <----------");
	}
	public List<Task> provideStatus(){
		// the status must be provided outside
		System.out.println("[WORKER-"+myid+"] providing the state to the controller...");
		return mypiece;
	}
	public String setStatusAndReply(List<Task> tsl) {
		setStatus(tsl);
		return null;
	}
	
}