<?xml version="1.0" encoding="UTF-8"?>
<ProActiveDescriptor xmlns="urn:proactive:deployment:3.3" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="./deployment.xsd">
  <!-- change with your values //-->
  <variables>
    <descriptorVariable name="PROACTIVE_HOME" value="${gridcomp}/distribution/lib/ProActive_3.90_beta"/>
    <descriptorVariable name="BESKE_HOME"  value="${gridcomp}/distribution/lib"/>
    <descriptorVariable name="EXAMPLES_HOME"  value="${gridcomp}/GridComp-Examples"/>
    <descriptorVariable name="REMOTE_USER"      value="${user}" />
    <descriptorVariable name="JAVA_HOME"      value="${javahome}" />
    <descriptorVariable name="REMOTE_PROACTIVE_HOME" value="${gridcomp}/distribution/lib/ProActive_3.90_beta"/>
    <descriptorVariable name="REMOTE_EXAMPLES_HOME"  value="${gridcomp}/GridComp-Examples"/>
    <descriptorVariable name="REMOTE_BESKE_HOME"  value="${gridcomp}/distribution/lib"/>
    <descriptorVariable name="REMOTE_JAVA_HOME"   value="${javahome}" />
  </variables>
  
  <componentDefinition>
    <virtualNodesDefinition>
      <virtualNode name="master-node"/>
      <virtualNode name="manager-node"/>
     
      <virtualNode name="slave-node"/>
      <#list deployablenodes as node>
      <virtualNode name="${node.name}"/>
      </#list>
      </virtualNodesDefinition>
  </componentDefinition>

  <deployment>
    <mapping>
        <map virtualNode="master-node">  <jvmSet><currentJVM/>                   </jvmSet> </map>
         <map virtualNode="manager-node">  <jvmSet><currentJVM/> </jvmSet> </map>
   
    	<map virtualNode="slave-node">   <jvmSet><currentJVM/>                   </jvmSet> </map>
       <#list deployablenodes as node>
    	<map virtualNode="${node.name}">  <jvmSet> <vmName value="${node.jvmName}"/> </jvmSet> </map>
    	</#list>
       </mapping>
    <jvms>
    <#list deployablejvm as javamachine>
<jvm name="${javamachine.name}"> <creation> <processReference refid="${javamachine.processName}" /> </creation> </jvm>
     </#list>
    </jvms>
  </deployment>

  <infrastructure>
    <processes>
       <processDefinition id="process-pianosau-1"> <sshProcess class="org.objectweb.proactive.core.process.ssh.SSHProcess" hostname="${localhostName}"> 
      <processReference refid="process-pianosau-local"/> </sshProcess> </processDefinition>
    
      <#list dp as place>
      <processDefinition id="${place.name}"> 
      <sshProcess class="org.objectweb.proactive.core.process.ssh.SSHProcess" hostname="${place.hostName}"> 
   	  <processReference refid="process-pianosau-remote"/> </sshProcess> 
   	  </processDefinition>
     </#list>  
  <processDefinition id="process-pianosau-remote">
        <jvmProcess class="org.objectweb.proactive.core.process.JVMNodeProcess">
		  <classpath>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-core.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-farm.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-map.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-manager.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-passive-mandelbrot.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-active-mandelbrot.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-dicom.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-passive-pi.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-active-pi.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-stateful-map.jar"/>
  				<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-stateless-map.jar"/>

                <absolutePath value="${REMOTE_PROACTIVE_HOME}/ProActive.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/fractal.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/asm-2.2.1.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/bouncycastle.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/dtdparser.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/fractal-adl.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/javassist.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/ganymed-ssh2-build210.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/junit-4.4.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/log4j.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/ow_deployment_scheduling.jar"/>
                <absolutePath value="${REMOTE_PROACTIVE_HOME}/xercesImpl.jar"/>
          </classpath>
          
          <javaPath>
		        <absolutePath value="${REMOTE_JAVA_HOME}/bin/java" />
		  </javaPath>
		  <policyFile>
		        <absolutePath value="${REMOTE_EXAMPLES_HOME}/proactive.java.policy" />
		  </policyFile>
		  <log4jpropertiesFile>
				<absolutePath value="${REMOTE_EXAMPLES_HOME}/proactive-log4j" />
		  </log4jpropertiesFile>
          <jvmParameters>
	        <parameter value="-Xmx512m"/>
            <parameter value="-Dworkers.max=${maxworkers}"/>
            <parameter value="-Dproactive.communication.protocol=rmissh"/>
          </jvmParameters>
	    </jvmProcess>
     </processDefinition>    
      <processDefinition id="process-pianosau-local">
        <jvmProcess class="org.objectweb.proactive.core.process.JVMNodeProcess">
		  <classpath>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-core.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-farm.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-map.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-manager.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-passive-mandelbrot.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-active-mandelbrot.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-dicom.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-passive-pi.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-active-pi.jar"/>
		  		<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-stateful-map.jar"/>
  				<absolutePath value="${REMOTE_BESKE_HOME}/gridcomp-stateless-map.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/ProActive.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/fractal.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/asm-2.2.1.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/bouncycastle.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/dtdparser.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/fractal-adl.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/javassist.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/ganymed-ssh2-build210.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/junit-4.4.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/log4j.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/ow_deployment_scheduling.jar"/>
                <absolutePath value="${PROACTIVE_HOME}/xercesImpl.jar"/>
          </classpath>
          
          <javaPath>
		        <absolutePath value="${JAVA_HOME}/bin/java" />
		  </javaPath>
		  <policyFile>
		        <absolutePath value="${EXAMPLES_HOME}/proactive.java.policy" />
		  </policyFile>
		  <log4jpropertiesFile>
				<absolutePath value="${EXAMPLES_HOME}/proactive-log4j" />
		  </log4jpropertiesFile>
          <jvmParameters>
	        <parameter value="-Xmx512m"/>
             <parameter value="-Dworkers.max=${maxworkers}"/>
           
            <!-- <parameter value="-Dproactive.communication.protocol=rmissh"/> -->
            <!-- <parameter value="-Dproactive.ssh.username=${REMOTE_USER}" /> -->
          </jvmParameters>
	    </jvmProcess>
     </processDefinition>    
    </processes>
  </infrastructure>
</ProActiveDescriptor>
