package gridcomp.autodeploy;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
public class ADLFarmWorkerTemplate {
 
 private String adlDir; // directory for adl.
 private String workerName; // name for the worker.
 private String workerADLDefinition; // adl file for the worker
 private String slaveNodeName = "\""; // 
 private StringBuffer tplBuffer = new StringBuffer();
 
// private String 
 public void setAdlDir(String adlDir)
 {
	 this.adlDir = adlDir;
 }
 public void setWorkerADLDefinition(String workerADLDefinition)
 {
	 this.workerADLDefinition = workerADLDefinition;
 }
 public void setSlaveNodeName(String nodeName)
 {
	 this.slaveNodeName = nodeName;
 }
 public void setWorkerName(String name)
 {
	 this.workerName = name;
 }
public String getWorkerName()
{
	return this.workerName;
}
 public void build()
 {
	String fName = adlDir + "." + workerName;
	tplBuffer.append("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>\n");
	tplBuffer.append("<!DOCTYPE definition PUBLIC \"-//objectweb.org//DTD Fractal ADL 2.0//EN\"\n");
	tplBuffer.append("\"classpath://org/objectweb/proactive/core/component/adl/xml/proactive.dtd\">\n");
	tplBuffer.append("<definition name=\""+ fName.trim() +"\""+" extends=\""+workerADLDefinition.trim()+"\">\n");
	tplBuffer.append("<virtual-node name=\""+slaveNodeName+"\" cardinality=\"single\"/>\n");
	tplBuffer.append("</definition>\n");
 }
 public void saveFile(String path) throws IOException
 {
	FileOutputStream outputStream = new FileOutputStream(path); 
	PrintWriter out = new PrintWriter(new OutputStreamWriter(outputStream));
	out.print(tplBuffer.toString());
	out.close();
 }
 public void clear()
 {
	 tplBuffer.delete(0, tplBuffer.capacity());
 }
}
