package gridcomp.autodeploy;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import freemarker.template.Configuration;
import freemarker.template.DefaultObjectWrapper;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import gnu.getopt.Getopt;
import gnu.getopt.LongOpt;

public class AutoDeploy {

	/**
	 * @param args
	 */
	public static void usage()
	{
    	System.out.println("usage gridcomp.AutoDeploy: ");
    	System.out.println("--maxWorkers\tmaxworkers\tMax No. workers to deploy");
    	System.out.println("--hostsFile\tinputFile\tfile which contains hostnames");
    	System.out.println("--outputFile\toutputFile\tDeployment file to be created");
    	System.out.println("--javaHome\tdirectory\tJAVA Home");
    	System.out.println("--adlDir\tdirectory\tDirectory where max workers adl needs to be generated");
    	System.out.println("--numNodes\tnodeNumber\tmaxNumber of nodes available");
    	System.out.println("--component\tdefinition\tstring which defines a component");
	
	}
	public static void usage1()
	{
    	System.out.println("usage gridcomp.AutoDeploy: ");
    	System.out.println("-w\tmaxworkers\tMax No. workers to deploy");
    	System.out.println("-f\tinputFile\tfile which contains hostnames");
    	System.out.println("-o\toutputFile\tDeployment file to be created");
    	System.out.println("-j\tdirectory\tJAVA Home");
    	System.out.println("-a\tdirectory\tDirectory where max workers adl needs to be generated");
    	System.out.println("-n\tnodeNumber\tmaxNumber of nodes available");
    	System.out.println("-ctdefinition\tstring which defines a component");
	
	}
	public static void main(String[] argv) {
		 int c;
		 String arg;
		 LongOpt[] longopts = new LongOpt[11];
		 // 
		 StringBuffer maxWorkersBuffer = new StringBuffer();
		 StringBuffer hostsFile = new StringBuffer();
		 StringBuffer outputFile = new StringBuffer();
		 StringBuffer numNodesBuffer = new StringBuffer();
		 StringBuffer adlDirBuffer = new StringBuffer();
		 StringBuffer javaHomeBuffer = new StringBuffer();
		 StringBuffer componentDef = new StringBuffer();
		 StringBuffer gridcompBinaryBuffer = new StringBuffer();
		 StringBuffer projectBuffer = new StringBuffer();
		 longopts[0] = new LongOpt("help", LongOpt.NO_ARGUMENT, null, 'h');
		 longopts[1] = new LongOpt("maxWorkers", LongOpt.REQUIRED_ARGUMENT, maxWorkersBuffer, 'w'); 
		 longopts[2] = new LongOpt("hostsFile", LongOpt.REQUIRED_ARGUMENT, hostsFile, 'f');
		 longopts[3] = new LongOpt("outputFile", LongOpt.REQUIRED_ARGUMENT, outputFile, 'o');
		 longopts[4] = new LongOpt("javaHome", LongOpt.REQUIRED_ARGUMENT, javaHomeBuffer, 'j');
         longopts[5] = new LongOpt("numNodes", LongOpt.REQUIRED_ARGUMENT,numNodesBuffer,'n');
		 longopts[6] = new LongOpt("adlDir",LongOpt.REQUIRED_ARGUMENT,adlDirBuffer,'a');
		 longopts[7] = new LongOpt("component",LongOpt.REQUIRED_ARGUMENT,componentDef,'c');
		 longopts[8] = new LongOpt("binaryPath",LongOpt.REQUIRED_ARGUMENT,gridcompBinaryBuffer,'b');
		 longopts[9] = new LongOpt("projectName",LongOpt.REQUIRED_ARGUMENT,projectBuffer,'p');
		 longopts[10] = new LongOpt("userName",LongOpt.REQUIRED_ARGUMENT,projectBuffer,'u');
				
		 // 
		Getopt g = new Getopt("gridcomp.AutoDeploy", argv, "hw:f:o:j:n:a:c:b:p:u:", longopts);
		g.setOpterr(false);
		String maxWorkers="1000";
		String inputMachines = "hosts.txt";
		String deployFileOutput = "distrib-deployment.xml";
		String javaHome = "/home/dazzi/jini/java15001";
		String adlDir = "gridcomp/example/active/dicom/adl/slaves";
		String gridcompBinary = "/home/dazzi/gridcomp/gridcomp/gridcomp";
		String workerADLDefinition = "gridcomp.example.active.dicom.adl.worker";
	    String projectName = "GridComp-Dicom-UseCase";
	    String userName = "dazzi";
		    	
		int numNodes = 30;
		
		int numOpt = 0;
		 //
		 while ((c = g.getopt())!= -1)
		   switch (c)
		     {
		       	
		         
		          //
		        case 0:
		        	System.out.println(c);
			        
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		maxWorkers = arg;
		        	System.out.println("Deployment configured with #workers: "+maxWorkers);
		        	break;
		          //
		        case 1:
		        	arg = g.getOptarg();
		        if (arg!=null)
		        	inputMachines = arg;
		         System.out.println("Hosts file configured: "+inputMachines);
		          break;
		          //
		        case 4:
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		deployFileOutput = arg;
		        	  System.out.println("Output File: "+deployFileOutput);
				       
		        	break;
		        case 5:
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		javaHome = arg;
		        	  System.out.println("JAVA_HOME: "+javaHome);
		
		        	break;
		        case 6:
		        	break;
		        case 7:
		        	break;
		        case 'a':
		        	++numOpt;
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		adlDir = arg.trim();
		        	  System.out.println("ADL Directory: "+adlDir);
		
		          break;
		        case 'b':
		        	++numOpt;
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		gridcompBinary = arg.trim();
		        	  System.out.println("GridCOMP main directory: "+gridcompBinary);
		
		          break;
		        case 'u':
		        	++numOpt;
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		userName = arg.trim();
		        	  System.out.println("Configured Username: "+userName);
		
		          break;
		
		        case 'j':
		        	++numOpt;
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		javaHome = arg.trim();
		        	  System.out.println("JAVA_HOME: "+javaHome);
		
		          break;
		        case 'n':
		        	++numOpt;
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		numNodes = Integer.parseInt(arg.trim());
		        	  System.out.println("#Nodes: "+numNodes);
		
		          break;
		        case 'c':
		        	++numOpt;
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        	workerADLDefinition = arg.trim();
		        	  System.out.println("Component Definition = "+workerADLDefinition);
		
		          break;
		
		          //
		        case 'o':
		        	++numOpt;
		        	arg = g.getOptarg();
		        	if (arg!=null)
		        		deployFileOutput = arg.trim();
		        	  System.out.println("Output File: "+deployFileOutput);
				    
		        	break;
		        case 'p':
		        	++numOpt;
		        	arg = g.getOptarg();
			        if (arg!=null)
			        	projectName = arg.trim();
			         System.out.println("Deployment for the project: "+projectName);
			          break;
		      
		        case 'f':
		        	++numOpt;
		        	arg = g.getOptarg();
			        if (arg!=null)
			        	inputMachines = arg.trim();
			         System.out.println("Hosts file configured: "+inputMachines);
			          break;
		          		          //
		        case 'h':
		        	usage1();
		          break;
		          //
		        case 'w':
		        {
		        	++numOpt;
		        if (g.getOptarg()!=null)
		        	  maxWorkers = g.getOptarg().trim();
		         System.out.println("Deployment configured with #workers: "+maxWorkers);
		          break;
		        }
		          //
		        case ':':
		          System.out.println("Doh! You need an argument for option " +
		                             (char)g.getOptopt());
		          break;
		          //
		        case '?':
		          System.out.println("The option '" + (char)g.getOptopt() + 
		                           "' is not valid");
		          break;
		          //
		        default:
		          System.out.println("getopt() returned " + c);
		          break;
		     }
		 //
		 
		 for (int i = g.getOptind(); i < argv.length ; i++)
		   System.out.println("Non option argv element: " + argv[i] + "\n");
		 
		  
		
		String deployTemplate = "deploy1.tpl";
		String pathDir = gridcompBinary.trim()+"/"+projectName.trim()+"/src/"+adlDir.trim();
	    String beskeName = "farm";
	    ArrayList<ADLFarmWorkerTemplate> adlFarm = new ArrayList<ADLFarmWorkerTemplate>();
	    
	    int nodeValue = 1;
	    
	    for (int i = 1; i<Integer.parseInt(maxWorkers)+1;++i )
	    {
	    	ADLFarmWorkerTemplate workerTemplate = new ADLFarmWorkerTemplate();
	    	workerTemplate.setAdlDir(adlDir.replace('/', '.'));
	    	workerTemplate.setWorkerADLDefinition(workerADLDefinition);
	    	if (nodeValue > numNodes)
	    	{ 
	    		nodeValue = 1;
	    	}
	    	
	    	workerTemplate.setSlaveNodeName("slave-node-"+nodeValue);
	    	workerTemplate.setWorkerName("slave-"+i);
	    	adlFarm.add(workerTemplate);
	    	++nodeValue;
	    }
	    for (ADLFarmWorkerTemplate wt: adlFarm)
	    {
	    	wt.build();
	    	try {
	    		String name = pathDir+"/"+wt.getWorkerName()+".fractal";  
	    		System.out.println("Writing file -->"+name);
				wt.saveFile(name);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
	/*
		if (args.length < 4)
		{
			System.err.println("Incorrect parameter numbers");
			System.exit(-1);
		}
		String maxWorkers = args[0];
		String userName = args[2];
		*/
	//ongOpt[] longopts = new LongOpt[3];
		 // 
		
		Configuration cfg = new Configuration();
		// Specify the data source where the template files come from.
		// Here I set a file directory for it:
		try {
			cfg.setDirectoryForTemplateLoading(
			        new File("."));
			Template temp = cfg.getTemplate(deployTemplate);
			Map root = new HashMap();
		    
		    root.put("user", userName);
	        root.put("gridcomp", gridcompBinary);
	        root.put("javahome", javaHome);
	        root.put("maxworkers",maxWorkers);
	        root.put("PROACTIVE_HOME",gridcompBinary+"/distribution/lib/ProActive_3.90_beta");
	        root.put("REMOTE_BESKE_HOME",gridcompBinary+"/distribution/lib");
	        root.put("REMOTE_PROACTIVE_HOME",gridcompBinary+"/distribution/lib/ProActive_3.90_beta");
	        root.put("REMOTE_JAVA_HOME",javaHome);
	        root.put("JAVA_HOME",javaHome);
	        root.put("REMOTE_EXAMPLES_HOME",gridcompBinary+"/"+projectName);
	        root.put("EXAMPLES_HOME",gridcompBinary+"/"+projectName);
	        root.put("REMOTE_USER",userName);
	        
	        File file = new File(inputMachines);
	        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
		  	LinkedList<String> hostNames = new LinkedList<String>();
	        String name = null;
	        
	        while ((name = reader.readLine())!=null)
	        {
	        	hostNames.add(name);
	        }
	        
	        
	        if (numNodes > hostNames.size())
		    	numNodes = hostNames.size();
	        ArrayList<Node> deployableNodes  = new ArrayList<Node>();
		  	  
	        for (int i = 1; i < numNodes; ++i)
	        {
          	Node n = new Node("slave-node-"+i,"slave-jvm-"+i);
	       	deployableNodes.add(n);
	        }
	        root.put("deployablenodes", deployableNodes);
	        ArrayList<JVM> deployableJvm  = new ArrayList<JVM>();
		  	
	        for (int i = 1; i < numNodes; ++i)
	        {
	           JVM nodeJVM = new JVM("slave-jvm-"+i, "process-distributed-"+i);
	           deployableJvm.add(nodeJVM);
	       }
	       root.put("deployablejvm", deployableJvm);
	       
	       ArrayList<Process> deployableHosts  = new ArrayList<Process>();
	       String hostName = hostNames.poll();
		   
	       root.put("localhostName",hostName);
	       
	        for (int i = 1; i < numNodes; ++i)
	        {
	        	hostName = hostNames.poll();
				
		    if (hostName!=null)
			{
		        Process nodeHost = new Process("process-distributed-"+i, hostName.trim());
			
	           deployableHosts.add(nodeHost);
			}
	       }
	       root.put("dp", deployableHosts);
	         
	    	Writer out = new OutputStreamWriter((new FileOutputStream(deployFileOutput)));
			try {
				temp.process(root, out);
			} catch (TemplateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			out.flush(); 
		} catch (IOException e) {
			e.printStackTrace();
		}
		// Specify how templates will see the data-model. This is an advanced topic...
		// but just use this:
		cfg.setObjectWrapper(new DefaultObjectWrapper());  
		
	}

}
