package gridcomp.autodeploy;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

public class Builder {
	
	static List<String> getHostList(File fd){
		List<String> ls = new ArrayList<String>();
		String row=null;
		BufferedReader in=null;
		try {
			in = new BufferedReader(new FileReader(fd));
			while ((row = (String)in.readLine())!=null){
				ls.add(row);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		try {
			in.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return ls;
	}
	
	public static void main(String[] args) {
		BufferedReader in=null;
		String row = null;
		String hostname=null;
		PrintStream ps=null;
		
		if (args.length<3){
			System.out.println("usage: java Builder <hostsfilename> <xmlfilename> <destfilename>");
			System.exit(-1);
		}
		
		List<String> ls = new ArrayList();
		ls = getHostList(new File(args[0]));
		try {
			ps = new PrintStream(new File(args[2]));
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
			System.exit(-1);
		}
		try {
			in = new BufferedReader(new FileReader(args[1]));
			row = in.readLine();
			String token=null;
			String newline=null;
			int i=0;
			while(row!=null){
				//System.out.println(row);
				newline = new String("");
				if (row.contains("$HOST_ID")){
					hostname = ls.get(i);
					newline = row.replaceAll("\\$HOST_ID",hostname);
					i=(i+1)%ls.size();
				}else
					newline = newline.concat(row);
				row = in.readLine();
				//System.out.println(newline);
				ps.println(newline);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		try {
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ps.flush();
		ps.close();
	}
}
