package gridcomp.example.active.dicom;

import gridcomp.example.dicom.io.DicomDecoder;
import gridcomp.example.dicom.io.DicomIOException;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Vector;
import java.util.concurrent.atomic.AtomicInteger;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.Body;
import org.objectweb.proactive.RunActive;
import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;
import org.objectweb.proactive.core.util.wrapper.StringWrapper;

import org.apache.log4j.Logger;

public class MasterImpl implements Master, BindingController, RunActive, MasterAttributes
{
    private Worker clientItf;
    private String imagesDir;
    private final byte endByte = 0;
    long start, end;
    private int items;
    private boolean init = false;
    private Logger logger = Logger.getLogger(MasterImpl.class.getName());

    public void runActivity(Body arg0) { 
    	 
    	 if (!init) {	
    		 logger.info("==============  B ===================");
    		 this.run(items);
    		 logger.info("==============  E ===================");
    		 init = true;
    	 }
    }
    
    public void run(int niter)
    {
    	
     	DicomDecoder DD = new DicomDecoder();
	    File dir = new File(imagesDir);
  		File[] files = dir.listFiles();
  		int h = 0;
  		int w = 0;
  		int counter = 0;
  		start=System.currentTimeMillis();
  		
  		if (files == null)
  		{
  		System.err.println("ERROR: Path directory error. Please check the image path in the adl.");	
  		return;
  		}
  		if (niter > files.length) {
			System.err.println("WARN: Not enough files. Required "+niter+" actual "+files.length);
		    niter = files.length;
		}
  		if (niter==-1)
  		{
  			niter = files.length;
  		}
		logger.info("--MA--> Waiting for manager to start");	
		
		try {
			Thread.sleep(5000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
		 }
		
		logger.info("--MA--> Waiting for manager to start, done");
  		for(int f=0; f<niter; f++) {
		    /* a file is  readable when: exists, i can read it, it's
		       not a dir 
		    */
  			boolean readAble = (files[f]!=null) && files[f].exists() && files[f].canRead() && !(files[f].isDirectory()) ;
			// && !(files[f].getName().startsWith(".") || files[f].getName().startsWith(".."));
  			
            if (!(readAble)) {
				logger.info("--MA--> Non readable file, skipping it :"+files[f]);				
			 
			}
			else
			{
				// This is moved into the worker in teh NFS version
			/*	
  			try {
  				if (DD!=null)
  					DD.getImageToDisplay(files[f].getAbsolutePath());
  			} catch (DicomIOException e) {
  				// TODO Auto-generated catch block
  				e.printStackTrace();
  				return;
  			}
  			
  		    w = DD.getWid();
  		    h = DD.getHe();

  		    short [] pixels = new short[w*h];

  		    byte [] b = new byte[w*h];
  		    pixels = DD.getIntValue();    // lettura non normalizzata
  		    int max = 0;
  		    for (int i=0;i<(w*h);i++)     // normalizzazione
  			if (pixels[i]>max) 
  			    max=pixels[i];
  		    for (int i=0;i<(w*h);i++) 
  			b[i]=(byte)((pixels[i]*255)/max);
  		    */
  		    clientItf.computeTask(files[f].getAbsolutePath(),counter);
  		    
			try {
					
				  if (f<2)
				  Thread.sleep(4000);
				  else
				  Thread.sleep(1000);
				  	
			if ((counter % 10)==0)
				logger.info("---MA--> Sending task "+counter);
		    } catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		    }
		    
  		    ++counter;
  		}
  		}
  		// end of stream
  		String eos = "__end__";
  		clientItf.computeTask(eos,-1);
  		/*
  		byte[] b = new byte[1];
  		b[0] = this.endByte;
  		clientItf.computeTask(b,-1);
	    */
		

      }
    
    
    public void bindFc(String clientItfName, Object serverItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
    	if (clientItfName.equals("do"))
                clientItf = (Worker) serverItf;
        else
            throw new NoSuchInterfaceException(clientItfName);
    }

    public String[] listFc() 
    {
    	return new String[]{"do"};
    }

    public Object lookupFc(String clientItfName) throws NoSuchInterfaceException 
    {
    	if (clientItfName.equals("do"))
            return clientItf; 
    else
        throw new NoSuchInterfaceException(clientItfName);
   }
    
    public void unbindFc(String clientItfName) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        
    	if (clientItfName.equals(Worker.ITF_NAME)) 
        	clientItf = null;
        else 
        	throw new NoSuchInterfaceException(clientItfName);
    }
    
    
	public String getDirectoryImages() {
		return imagesDir;
	}

	public int getItems() {
		return items;
	}

	public void setItems(int num) {
		items = num;
	}

	public void setDirectoryImages(String dirName) {
		
		imagesDir = dirName; 
	}
}
