package gridcomp.example.active.dicom.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Image;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
/* ImageFrame is the view of MVC pattern, which I use
 * in this application. The model has been implemented in ImageModelImpl.
 */
public class ImageFrame extends JFrame implements ImageModelListener {
	private static final long serialVersionUID = -5519182118243448439L;
	private ImageModel model;
	private JScrollPane jsp;
	private JPanel panel;
/* Construct the view for this application.
 * @param title title of the window.
 * @param model the model for this application, where images should be
 * stored.
 */
public ImageFrame(String title, ImageModel m)
{
 super(title);
 model = m;
 panel = new JPanel();
 panel.setLocation(0,0);
 panel.setLayout(new FlowLayout(FlowLayout.LEFT));
 panel.setPreferredSize(new Dimension(800, 600));
 model.addModelListener(this);
 this.setLayout(new BorderLayout());
 this.setMinimumSize(new Dimension(800, 600));
 this.setResizable(true);
 jsp = new JScrollPane(panel);
 jsp.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
 jsp.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
 jsp.setMinimumSize(new Dimension(800, 600));
 jsp.setSize(this.getWidth(), this.getHeight());
 this.setContentPane(jsp);

}
public void update(String name) {
	Image img = model.getImage(name);
	if (img!=null)
	{
		ThumbImage control = new ThumbImage(img);
		control.setLabel(name);
		int xBound=-1;
		int yBound;
		int posComponent=-2;
		Component component = control;
		if (panel.getComponentCount()>0)
		{
		component = panel.getComponent(panel.getComponentCount()-1);
		xBound = jsp.getVisibleRect().width - control.getScaleWidth();
		yBound = jsp.getVisibleRect().height - control.getScaleHeight();
		posComponent = component.getX()+control.getScaleWidth();
		if (component.getY()+control.getHeight()>yBound)
		{
		panel.setPreferredSize(new Dimension(panel.getWidth(), panel.getHeight()*2));
		panel.setMinimumSize(new Dimension(panel.getWidth(), panel.getHeight()*2));
		}
		if (posComponent<xBound-10)
		{
		control.setLocation(posComponent, component.getY());
		} 
		else {
		 control.setLocation(0, component.getY()+control.getScaleHeight()+30);
		}
		} else {
			control.setLocation(0, 0);
		}
		panel.add(control);
		jsp.getViewport().revalidate();
	}
}
}
