package gridcomp.example.active.dicom.gui;

import gridcomp.example.dicom.gui.ImageFrame;
import gridcomp.example.dicom.gui.ImageModelImpl;
import gridcomp.example.dicom.gui.ImageModel;
import gridcomp.example.dicom.io.DicomDecoder;

import java.io.File;
import java.io.IOException;

import javax.swing.JFrame;

public class MainViewer {

	/**
	 * @param args
	 */
	
	public static void main(String[] args) {
		if (args.length < 1)
		{
			System.err.println("Image Directory needed!");
			System.exit(-1);
		}
		String dicomFiles =  args[0];
		int j = 0;
		if (dicomFiles!=null)
		{
		DicomDecoder DD = new DicomDecoder();
	
		  	
		ImageModel model = new ImageModelImpl();
    	ImageFrame view = new ImageFrame("Dicom Viewer",model);
    	view.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		view.setResizable(true);
		view.setSize(1023, 768);
		view.pack();
		view.setVisible(true);
		File dir = new File(dicomFiles);
		File[] files = dir.listFiles(new DicomFileNameFilter());
		for (File f: files)
		{
			boolean readAble = f.isFile() && f.exists() && f.canRead() && !f.isDirectory();
			
  			if (readAble)
  			{
  			try {
  				DD.getImageToDisplay(f.getAbsolutePath());
  			} catch (IOException e) {
  				// TODO Auto-generated catch block
  				e.printStackTrace();
  			}
  		    int w = DD.getWid();
  		    int h = DD.getHe();
  		    short [] pixels = new short[w*h];
  		    byte [] b = new byte[w*h];
  		    pixels = DD.getIntValue();    // lettura non normalizzata
  		    int max = 0;
  		    for (int i=0;i<(w*h);i++)     // normalizzazione
  			if (pixels[i]>max) 
  			    max=pixels[i];
  		    for (int i=0;i<(w*h);i++) 
  			b[i]=(byte)((pixels[i]*255)/max);
  		    model.addImage("Image_"+j, b);
  		    ++j;
  			}
		}

		}
	}
}

