package gridcomp.example.passive.dicom;



import gridcomp.farm.gui.JFarm;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.swing.JFrame;

import org.objectweb.fractal.adl.ADLException;
import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.util.Fractal;

import org.objectweb.proactive.api.PADeployment;
import org.objectweb.proactive.core.ProActiveException;
import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.descriptor.data.ProActiveDescriptor;

public class Main
{
	private Master itf = null;
	private Component farm = null;
	private Component owner = null;
	private static int niter = 50;
	private static JFarm farmGUI;
	public Main()
	{
	}
	
	private Master getMasterInteface()
	{
		return this.itf;
	}
	private Component getFarm()
	{
		return farm;
	}
	private void setComponent(Component owner)
	{
		this.owner =owner;
	}
	private ProActiveDescriptor setupProActive() throws ProActiveException
	{
		ProActiveDescriptor pad = null;
		   
    	Properties programProperties = System.getProperties();
        programProperties.setProperty("java.security.manager", new String());
        programProperties.setProperty("java.security.policy", "proactive.java.policy");
        programProperties.setProperty("fractal.provider", "org.objectweb.proactive.core.component.Fractive");
        programProperties.setProperty("log4j.configuration", "file:proactive-log4j");
        programProperties.setProperty("deployment.descriptor", "local-deployment.xml");
        System.setProperties(programProperties);
     
        System.setProperties(programProperties);
        pad = PADeployment.getProactiveDescriptor(System.getProperty("deployment.descriptor"));
		System.out.println("Loaded " + System.getProperty("deployment.descriptor"));
		pad.activateMappings();
		return pad;
	}
	private void setMasterInterface(Component root) throws NoSuchInterfaceException
	{
		MasterAttributes ma = null;
		setComponent(root);
		itf = (Master)root.getFcInterface(Master.ITF_NAME);
		ContentController cc = (ContentController) root.getFcInterface(Constants.CONTENT_CONTROLLER);//, fcc = null;
	    Component comps[] = cc.getFcSubComponents();
	   
	     for (Component c: comps)
	        	if (Fractal.getNameController(c).getFcName().equals("client")) {
	        		ma  = (MasterAttributes)    c.getFcInterface(Constants.ATTRIBUTE_CONTROLLER);
	        		niter = ma.getItems();
	        	} else if (Fractal.getNameController(c).getFcName().equals("farm")) {
	        		farm = c;
	        	}
	     
	   //ma.setDirectoryImages("/home/giorgio/working/GridComp-Dicom-UseCase/resources");
	}
    public static void main(String[] args)
    {
    	Main mainClass = new Main();
    	ProActiveDescriptor pad = null;
    	try {
    	 pad = mainClass.setupProActive();
    	} catch (ProActiveException e)
    	{
    		e.printStackTrace();
    		System.exit(-1);
    	}
    	
    	Map<String, Object> context = new HashMap<String, Object>(1);
        context.put("deployment-descriptor", pad);
        Factory fact;
		Component root = null;
       // here we 
	
        try {
			fact = gridcomp.adl.FactoryFactory.getFactory();
	
        root =  (Component) fact.newComponent("gridcomp.example.passive.dicom.adl.root", context);
        try {
        	mainClass.setMasterInterface(root);
            
            Fractal.getLifeCycleController(root).startFc();
		} catch (IllegalLifeCycleException e) {
			e.printStackTrace();
			System.exit(-1);
		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.exit(-1);
			
		}
  
		} catch (ADLException e) {
			e.printStackTrace();
			System.exit(-1);
		}
        Master masterWorker = mainClass.getMasterInteface();
    	createGraphicalInterface(mainClass.getFarm(), "worker");

        masterWorker.run(niter);
               // Active wait... no other workaround possible!
        //createGraphicalInterface(mainClass.getFarm(), "worker");
       /*  
        try {
			Fractal.getLifeCycleController(root).stopFc();
		} catch (IllegalLifeCycleException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        System.exit(0);*/
    }
    private static void createGraphicalInterface(Component owner, String name)
    {
        JFrame frame = new JFrame("Autonomic Behavior Controller");
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        frame.setResizable(false);
        farmGUI = new JFarm(owner, name, true);
        frame.getContentPane().add(farmGUI);
        frame.pack();
        frame.setVisible(true);
    }

}
