package gridcomp.usescase.dicom.sequential;



import java.awt.image.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

class DicomSegmenter extends JFrame {
 
  	private static int WIDTH = 570;
	private static int HEIGHT = 340;
	private static String TITLE = "Dicom Segmenter";
	private Container frameContainer;
	private ImagePanel imagePanel;
	private JFileChooser choser;
	private boolean bGrayComp=false;
	private short pixels[][];
        private short segmentedPixels[][];
	private int w,h,counter,nDicomFiles,gCenter;
	
	// Interfaccia Grafica 
	JMenuBar menuBar = new JMenuBar();
	JMenu fileMenu = new JMenu("File");
	JMenuItem fileOpen = new JMenuItem("Open...");
	JMenuItem fileClose= new JMenuItem("Close");
	JMenuItem fileExit = new JMenuItem("Exit");
	JMenu editMenu = new JMenu("Edit");
	JMenuItem editSegment = new JMenuItem("Segmentazione"); 
	JSlider grayCenter = new JSlider(JSlider.HORIZONTAL,-50, 50, 0);
	JPanel pane;
	JButton button1 = new JButton("Avanti");
	JButton button2 = new JButton("Indietro");
	JButton button3 = new JButton("Inizio");
	JCheckBoxMenuItem grayComp = new JCheckBoxMenuItem("Gray comp.");

	
	public DicomSegmenter() {
		super(TITLE);
		setupMenuBar();
		frameContainer = getContentPane();
		setupEventHandlers();
		setSize(WIDTH,HEIGHT);
		initParam();
		setupPanels();
		choser = new JFileChooser();
		show();
		int[] initSegmPix = new int[w*h];
  		for (int i=0;i<(w*h);i++) {
  			initSegmPix[i]= (int)(i/255);
  			initSegmPix[i]=(((0xff)<<24)|((initSegmPix[i]&0xff)<<16)|((initSegmPix[i]&0xff)<<8)|((initSegmPix[i]&0xff)));
  		}
  		imagePanel.image= Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(w, h,initSegmPix, 0, w));
		imagePanel.image1= Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(w, h,initSegmPix, 0, w));
		imagePanel.repaint();
	}
 
	void initParam() {
  		w=256;h=256;counter=0;
  		nDicomFiles=30;
	}
 
	void setupPanels() {
	  	grayCenter.addChangeListener(new SliderListener());
		grayCenter.setMajorTickSpacing(10);
		grayCenter.setMinorTickSpacing(1);
		imagePanel = new ImagePanel(null,null);
		pane = new JPanel();
		pane.add("West",button1);
		pane.add("West",button2);
		pane.add("West",button3);
		pane.add("Center",grayCenter);
		pane.add("East",grayComp);
		frameContainer.add(pane, BorderLayout.SOUTH);
		frameContainer.add(imagePanel, BorderLayout.CENTER);
		setMenu(false);
		frameContainer.setVisible(true);
	}
	
	void setMenu(boolean Value) {
		grayCenter.setEnabled(Value);
		button1.setEnabled(Value);
		button2.setEnabled(Value);
		button3.setEnabled(Value);
		grayComp.setEnabled(Value);
		editMenu.setEnabled(Value);
		fileOpen.setEnabled(!Value);
		fileClose.setEnabled(Value);
	}

	void setupMenuBar() {
		fileMenu.add(fileOpen);
		fileMenu.add(fileClose);
		fileMenu.add(fileExit); 
		editMenu.add(editSegment); 
		menuBar.add(fileMenu);
		menuBar.add(editMenu);
		setJMenuBar(menuBar);
	}
 
	void setupEventHandlers() {
		addWindowListener(new WindowHandler());
		fileOpen.addActionListener(new MenuItemHandler());
		fileClose.addActionListener(new MenuItemHandler());
		fileExit.addActionListener(new MenuItemHandler());
		editSegment.addActionListener(new MenuItemHandler());
		button1.addActionListener(new MenuItemHandler());
		button2.addActionListener(new MenuItemHandler()); 
		button3.addActionListener(new MenuItemHandler());
		grayComp.addItemListener(new ItemHandler());
	}
	public void openImage()
    {
      	String file,dir_;
      	FileDialog dialogBox = new FileDialog(this,"open DICOM files");
      	dialogBox.setFile("*.*");
      	dialogBox.show();
      	dir_=dialogBox.getDirectory();
      	if((file=dialogBox.getFile()) != null)
		{
		   	int i;
			int length = file.length();
			for(i=0;i<length;i++) if (file.substring((length-i-1),(length-i)).equals(".")) break;
			file = file.substring(0,(length-i));
			DicomDecoder DD = new DicomDecoder();
			System.out.print("Sto verificando il numero totale di files...");
			for (i=1;i>0;i++) if(!(DD.getImageToDisplay(dir_+file+i))) break;
			nDicomFiles=(i-1);
			System.out.println(" Finito !!!   Totale files -->"+nDicomFiles);
			w=DD.getWid();
			h=DD.getHe();
			pixels = new short[nDicomFiles+1][w*h];
			segmentedPixels = new short[nDicomFiles+1][w*h];
			for (i=1;i>0;i++){
	 			if (!(DD.getImageToDisplay(dir_+file+i))) break;
				pixels[i]=DD.getIntValue();
				if (!(pixels[i]==null))	System.out.println("Img n� "+i);
	  			}
			counter=1;
			if (!(pixels[counter]==null)) {
				System.out.println("File "+file+" Loaded\n");
				System.out.println("Tot. files loaded --> "+(--i));
			}
		}
      	setMenu(true);
      	visualizza(pixels[counter],1);
      	dialogBox.dispose();
 		
	}
	
	public void close() {
		setMenu(false);
  		int[] initSegmPix = new int[w*h];
  		for (int i=0;i<(w*h);i++) {
  			initSegmPix[i]= (int)(i/255);
  			initSegmPix[i]=(((0xff)<<24)|((initSegmPix[i]&0xff)<<16)|((initSegmPix[i]&0xff)<<8)|((initSegmPix[i]&0xff)));
  		}
  		imagePanel.image= Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(w, h,initSegmPix, 0, w));
		imagePanel.image1= Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(w, h,initSegmPix, 0, w));
		repaint();
		pixels=null;
		System.gc();
		imagePanel.repaint();
	}
		
	
	public void visualizza(short[] pix,int image) {
      	ColorModel cm = grayColorModel();
		byte[] destPixels = new byte[w * h] ;
		int max=0;
		if (!(pix==null)) {
			if (bGrayComp){
				for (int i=0;i<(w*h);i++) {
		 			if (pix[i]>max) max=pix[i];
		 		}
				for (int i=0;i<(w*h);i++) {
					destPixels[i]=(byte)(((float)pix[i]*255)/max);
				}
			}
			else {
				for (int i = 0 ; i < w*h ; i++ ){
					int intVal=(pix[i]+(gCenter)*6);
					if (intVal>255) intVal=255; 
					if (intVal<0) intVal=0;
					destPixels[i]=(byte)intVal;
				}
			}
			if(image==1) imagePanel.image= Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(w, h,cm,destPixels, 0, w));  
			else imagePanel.image1= Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(w, h,cm,destPixels, 0, w)); 
	 		//System.out.println("Frame n ---> "+counter);
		}
 		repaint();
 		System.gc();
 		imagePanel.repaint();
		
	}
	

 	public void avanza() {
	 	counter++;
		if (counter>nDicomFiles) counter=1;
		visualizza(pixels[counter],1);
		if (!(segmentedPixels[counter]==null)) visualizza(segmentedPixels[counter],2);
	}


  	public void indietro() {
 		counter--;
		if (counter==0) counter=nDicomFiles;
		visualizza(pixels[counter],1);
		if (!(segmentedPixels[counter]==null)) visualizza(segmentedPixels[counter],2);
	}

 	public void inizio() {
 		counter=1;
 		visualizza(pixels[counter],1);
		if (!(segmentedPixels[counter]==null)) visualizza(segmentedPixels[counter],2);
	}
	
 	public static void main(String[] args) {
	    
	    DicomSegmenter app = new DicomSegmenter();
	}

 	public class WindowHandler extends WindowAdapter {
  		public void windowClosing(WindowEvent e) {
   			System.exit(0);
  		}
 	}

 	public class MenuItemHandler implements ActionListener {
  		public void actionPerformed(ActionEvent e) {
   			String cmd = e.getActionCommand();
			if(cmd.equals("Exit")) System.exit(0);
			if(cmd.equals("Open...")) openImage();
			if(cmd.equals("Close")) close();
			if(cmd.equals("Segmentazione")) {
			    Scheduler s = new Scheduler(1,nDicomFiles,w,h,pixels);
			    segmentedPixels=s.segm();
			    visualizza(segmentedPixels[counter],2);
			}

			if(cmd.equals("Avanti")) avanza();
			if(cmd.equals("Indietro")) indietro();
			if(cmd.equals("Inizio")) inizio();
		}
 	}
	
	public class ItemHandler implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
   			AbstractButton b = (AbstractButton)e.getItem();
   			String txt = b.getText();
   			bGrayComp=grayComp.isSelected();
 			visualizza(pixels[counter],1);
		} 	
 	}
 	
	public ColorModel grayColorModel(){
		byte[] r = new byte[256] ;
		for (int i = 0; i <256 ; i++ ) r[i] = (byte)(i & 0xff ) ;
		return (new IndexColorModel(8,256,r,r,r));
	}

 
	class SliderListener implements ChangeListener {
    	public void stateChanged(ChangeEvent e) {
        	JSlider source = (JSlider)e.getSource();
            if (!source.getValueIsAdjusting()) {
            	gCenter = (int)source.getValue();
                System.out.println(" valore gCenter ---> "+gCenter);
			   	byte[] destPixels = new byte[w * h] ;
			   	int max=0;
				if (bGrayComp){
					for (int i=0;i<(w*h);i++) {
					if (pixels[counter][i]>max) max=pixels[counter][i];
				 	}
				System.out.println("Max -> "+max);
				for (int i=0;i<(w*h);i++) {
					destPixels[i]=(byte)(((float)pixels[counter][i]*255)/max);
					}
				}
				else {
					for (int i = 0 ; i < w*h ; i++ ){
						int intVal=(pixels[counter][i]+(gCenter)*6);
						if (intVal>255) intVal=255; 
						if (intVal<0) intVal=0;
						destPixels[i]=(byte)intVal;
					}
				}
				ColorModel cm = grayColorModel();
				imagePanel.image= Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(w, h,cm,destPixels, 0, w));
			 	System.out.println("Frame n ---> "+counter);
			   	repaint();
			   	imagePanel.repaint();
	    	}
        }
	} 
	   
}

