package gridcomp.usescase.dicom.sequential;

public class Scheduler implements Runnable {			
    int first,last,counter,w,h;
    short[][] pixels;
    short[][] segmImagePix;
    int nFarm;
   // SegmenterInterface SegInt;
    int nWorkerFree;
    
    public Scheduler(int f,int l,int width,int height,short[][] pix)	{
	first=f;
	last=60;
	w=width;
	h=height;
	pixels=pix;
	segmImagePix=new short[(last-first+2)][w*h];
	nFarm=15;
	counter=1;
	nWorkerFree=nFarm;
    }

    short[][] segm() {
	if ((1+last-first)<nFarm) nFarm=(1+last-first);
	long StartTime,EndTime;
	StartTime=System.currentTimeMillis();
	for (int i=1;i<=nFarm;i++) {
	    Thread t = new Thread(this);
	    t.setName("alpha"+i);
	    t.setDaemon(true);
	    nWorkerFree--;
	    t.start();
	}
	while (nWorkerFree!=nFarm) try {
	    Thread.currentThread().sleep(100);}
	catch (InterruptedException e) { }
	EndTime=System.currentTimeMillis();
	System.out.println("Tempo totale impiegato con "+nFarm+" Worker -->"+(EndTime-StartTime) );
	System.gc();
	return segmImagePix;
    }

    public void run () {
	long start,end;
	for(;;) { 
	    if (counter<=(last-first+1)) {
		try {
		    byte[] b = new byte[65536];
		    
		   Segmenter s=new Segmenter();
		    
		    System.out.println(Thread.currentThread().getName()+" sta elaborando il frame "+counter);
		    start=System.currentTimeMillis();
    		int currentFrame=counter++;
        	short max=0;
			for (int i=0;i<(w*h);i++) if (pixels[currentFrame][i]>max) max=pixels[currentFrame][i];
			for (int i=0;i<(w*h);i++) b[i]=(byte)((pixels[currentFrame][i]*255)/max);	
		    s.execTask(b);
		    for(int i=0;i<(w*h);i++) segmImagePix[currentFrame][i]=(short)(b[i]&0xff);
		    
		    end=System.currentTimeMillis();
		    System.out.println(Thread.currentThread().getName()+" ha impiegato "+(end-start)+" millisecondi");
		} catch (Exception ex){
		    System.out.println(ex);
		    ex.printStackTrace();
		}    
//		SegInt=null;
	    }
	    else {
		nWorkerFree++;
		System.gc();
		break;
	    }
	}
	
	
    }
    
}
    
    




