package gridcomp.usescase.dicom.sequential;
import java.awt.image.*;
import java.awt.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class Segmenter {
	
	private static int w=256;
    private static int h=256;

	public Segmenter()  {
	   	
 	}
	
	public ColorModel grayColorModel(){
		byte[] r = new byte[256] ;
		for (int i = 0; i <256 ; i++ ) r[i] = (byte)(i & 0xff ) ;
		return (new IndexColorModel(8,256,r,r,r));
	}

 
 	public byte[] execTask(byte[] b)  {
	    //byte[] b = ((byte[])(ba));
	 //   Image image;
	    short LArray[] = new short[w*h];
	    short segpixels[]=new short[w*h];
	    byte[] segmImagePixels=new byte[w*h];
	    short newImg[];
	    long start,init,end;
	    short pix[] = new short[w*h];

		start = System.currentTimeMillis();
		init = start;
		for(int i=0;i<(w*h);i++) pix[i]=(short)(b[i]&0xff);

		LArray=doHistogramRGBtoLUV(pix,w,h);
	   	end = System.currentTimeMillis();
		System.out.println("Tempo I   Stadio --> "+(end-start));
	
		newImg = doDynamic(LArray,w,h,50,40);
	   	start = System.currentTimeMillis();
		System.out.println("Tempo II  Stadio --> "+(start-end));
	
	   	segpixels=prepareResult(w,h,newImg);

		for(int i=0;i<(w*h);i++) segmImagePixels[i]=(byte)(segpixels[i]);
	
	    end = System.currentTimeMillis();
	    System.out.println("Tempo III Stadio --> "+(end-start)+"\n");
	    //DelayValue.delay(500);
	    end = System.currentTimeMillis();
	    System.out.println("Tempo finale-->" +(end-init));
	    return ((byte[])(segmImagePixels));
	}
 

	public short[] doHistogramRGBtoLUV(short[] pix,int w,int h)   {
 	
	    int[] colorCoord_;
	    int[] valRGB_;
	    int[] histogram_;
		
		int npixels = w * h;
		int pk, bc;
		int[] first_tab = new int[262144];
		for(int j=0; j<262144; j++)
		    first_tab[j]=0;
		int k;
		for (k = 0; k < npixels; k++) {
			pk = pix[k];
		  	bc = pk & 0xff;		
		  	first_tab[(((bc<<8) + bc) << 2) + (bc>>6)]++;
		}
		colorCoord_ = new int[262144];
		for(int j=0; j<262144; j++) colorCoord_[j]=0;
		int first_count = 0;
		for (k = 0; k < 262144; k++) {
			if (first_tab[k] != 0) {
				colorCoord_[k] = first_count;
				first_count++;
		    }
		}
		int[] fourth_tab = new int[first_count];
		for(int j=0; j < first_count; j++)
		    fourth_tab[j]=0;
	
		int[][] third_tab  = new int[first_count][];
	
		first_count = 0;
		for (k = 0; k < 262144; k++) {
		    if (first_tab[k] != 0) {
				third_tab[first_count] = new int[first_tab[k]];
				first_count++;
	  	    	}
	        }
		for (k = 0; k < npixels; k++) {
			pk = pix[k];
	  	  	bc = pk & 0xff;		
		  	int sec_ind = bc & 63;
		  	int third_ind = colorCoord_[(((bc<<8) + bc) << 2) + (bc>>6)];   
		  	third_tab[third_ind][fourth_tab[third_ind]] = sec_ind;
		  	fourth_tab[third_ind]++;      
		}
		int[] fifth_tab = new int[64];
		int ncolors_ = 0;
		for (k = 0; k < first_count; k++) {
		    int j;
		    for (j=0; j < 64 ; j++)
		    	fifth_tab[j]=0;
		    for (j = 0; j < fourth_tab[k]; j++) {
				fifth_tab[third_tab[k][j]]++;
		    }
		    for (j = 0; j < 64; j++) {
				if (fifth_tab[j] != 0) {
			    	ncolors_++;
				}
		    }
		}
		valRGB_ = new int[ncolors_];
		histogram_ = new int[ncolors_];
	
		int p = 0;
		k = 0;
		for (int r = 0; r < 262144; r++) {
		    if (first_tab[r] != 0) {
				int j;
				for (j = 0; j < 64; j++) {
			    	fifth_tab[j] = 0;
				}
				for (j = 0; j < fourth_tab[k]; j++) {
			    	fifth_tab[third_tab[k][j]]++;
				}
				colorCoord_[r] = p;
				for (j = 0; j < 64; j++) {
			    	if (fifth_tab[j] != 0) {
						valRGB_[p] = (r<<6) + j;
						histogram_[p] = fifth_tab[j];
						p++;
				    	}
					}
				third_tab[k]=null;
				k++;
			}
		}
		third_tab =null;
		fourth_tab=null;
		fifth_tab =null;
		first_tab =null;
		System.gc();
		//System.out.println("Region Colors: " + ncolors_+"\n");
			
		final int XYZ[][] = {	
			{ 4125, 3576, 1804 },
			{ 2125, 7154,  721 },
			{  193, 1192, 9502 }
		};
		final float RGB[][] = { 
			{ 3.2405f, -1.5371f, -0.4985f },
			{-0.9693f,  1.8760f,  0.0416f },
			{ 0.0556f, -0.2040f,  1.0573f }
		};
		
		int MAXV = 256;
		int a00 = XYZ[0][0], a01 = XYZ[0][1], a02 = XYZ[0][2];
		int a10 = XYZ[1][0], a11 = XYZ[1][1], a12 = XYZ[1][2];
		int a20 = XYZ[2][0], a21 = XYZ[2][1], a22 = XYZ[2][2];
		int[] A00 = new int[MAXV];
		int[] A01 = new int[MAXV];
		int[] A02 = new int[MAXV];
		int[] A10 = new int[MAXV];
		int[] A11 = new int[MAXV];
		int[] A12 = new int[MAXV];
		int[] A20 = new int[MAXV];
		int[] A21 = new int[MAXV];
		int[] A22 = new int[MAXV];
		float Un_prime = 0.1978f;
	 	float Vn_prime = 0.4683f;
	 	float Lt = 0.008856f;
		int j;
		for (j = 0; j < MAXV; j++) {
		    A00[j] = a00*j;  A01[j] = a01*j;  A02[j] = a02*j;
		    A10[j] = a10*j;  A11[j] = a11*j;  A12[j] = a12*j;
		    A20[j] = a20*j;  A21[j] = a21*j;  A22[j] = a22*j;
		}
		 
		float[] my_pow = new float[MAXV];
		for (j = 0; j < MAXV; j++) {
		    my_pow[j]= 116.0f * (float) Math.pow(j/255.0, 0.3333333) - 16.0f;
		}
		
		short L_data_[] = new short[npixels];
		short u_data_[] = new short[npixels];
		short v_data_[] = new short[npixels];
		int valL_[] = new int[ncolors_];
		int valu_[] = new int[ncolors_];
		int valv_[] = new int[ncolors_];
		int colorIdx_[] = new int[npixels];
		int temp_col, R, G, B, x, y, z, my_temp ;
		float tval, l_star, u_prime, v_prime, u_star, v_star;
	
		for (j = 0; j < ncolors_; j++) {
			temp_col = valRGB_[j];
	
		    R = temp_col >> 16;
		    G = (temp_col >> 8) & 255;
		    B = temp_col & 255;
	
		    x = A00[R] + A01[G] + A02[B];
		    y = A10[R] + A11[G] + A12[B];
		    z = A20[R] + A21[G] + A22[B];
	
		    tval = y / 2550000.0f;		
	
		    l_star = my_pow[(int) (tval*255.0f + 0.5f)];
		    if (tval <= Lt) {
				l_star = 903.3f * tval;
		    }
		    my_temp = x + 15 * y + 3 * z;
		    valL_[j] = (int) (l_star+0.5);
		}
		int pj, tmp_idx, temp_index;
		for (j = 0; j < npixels; j++) {
			pj = pix[j];
	   	  	bc = pj & 0xff;	
		    temp_col = (((bc << 8) + bc) << 8) + bc;
		    tmp_idx = colorCoord_[temp_col >> 6];
		    temp_index = 0;
		    for (k = tmp_idx; k < tmp_idx + 64; k++) {
				if (valRGB_[k] == temp_col) {
				    temp_index = colorIdx_[j] = k;
				    break;
				}
		    }
		    L_data_[j] = (short)valL_[temp_index];
		}
	    //System.out.println("Finito conversione RGBtoLUV ");
	    return L_data_;
	}

  
	public short[] doDynamic(short[] Ldata_,int width_,int height_,int colorRes,int spatialRes) 
	{
	   	int k, j, u, i;
	    int nPixels_=width_*height_;
	    float radiusD = spatialRes/10.0f;
		//System.out.println("RadiusD: "+radiusD+"\n");
		float radiusR = colorRes/10.0f;
		//System.out.println("RadiusR: "+radiusR+"\n");
		int peakAddr_[][]= new int[3][nPixels_];
		short newImage_[]= new short[nPixels_];
		Vector peaks_[][]= new Vector [1][];
		Vector coords_[][]= new Vector [1][];
		int colors_[][]= new int[3][nPixels_];
		int genCounter_;
		float H = 0.499999f;
		int genItCount =0;
		float radiusD2 = radiusD*radiusD;
		float radiusR2 = radiusR*radiusR;
		int N = (int)(radiusD);
		int newVal0, newVal1, newVal2;
		float fNewVal0, fNewVal1, fNewVal2, mVal0, mVal1, mVal2;
		int tempTab[];
		int vectorSize;
		int distD2;    
		float distR2=0f;  
		int winY, winX,depl, center, newX, newY, loops=0;
		int wSum, xSum = 0, ySum = 0;
		float dif0, dif1, dif2, difX=0, difY=0;
		peaks_[0] = new Vector [nPixels_];
		Vector peaks[] = peaks_[0];
		genCounter_=0;
		//System.out.println("Mean Shift ... ");  

// Inizio Algoritmo
      
		for(winY = 0; winY < height_; winY ++)
	    {
	    	for(winX = 0; winX < width_; winX ++) 
	        {
	        	center = winY * width_ + winX; 
	          	mVal0 = Ldata_[center]; mVal1 = 0;
	          	mVal2 = 0;
	          	newX = winX; newY = winY;          
	          	for(loops = 0; loops<10; loops++)
	            {
	            	wSum = 0; newVal0 = 0; newVal1 = 0; newVal2 = 0;
	              	xSum = 0; ySum = 0; 
	              	for(i = -N; i < N; i++)
		            {
		            	k = newY + i;
		              	if(k<0 || k>= height_) continue;
		              	depl = k*width_;
		              	for(j = -N; j < N; j++)
		                {
		                	k = newX + j;
		                  	if(k<0 || k>= width_) continue;
		                  	k += depl;
		                  	dif0 = Ldata_[k]-mVal0;  
		                  	if(dif0 < 0) dif0 = -dif0;
		                  	if(mVal0 > 80) dif0 *= 2;
		                  	if(dif0<radiusR){
		                    	dif1 = 0-mVal1; 
		                    	dif2 = 0-mVal2;
		                    	distR2 = (dif0*dif0 + dif1*dif1 + dif2*dif2)/radiusR2
		                           + (i*i  + j*j)/radiusD2;
		                    	if(distR2 < 1.0)
		                      	{
		                        	wSum ++; xSum+=j; ySum+=i;
		                        	newVal0+=Ldata_[k];
		                        	newVal1+=0;
		                        	newVal2+=0;
		                      	}
		                    }
		                }
		            }
		           	fNewVal0 = (float)newVal0/wSum; fNewVal1 = (float)newVal1/wSum; 
		          	fNewVal2 = (float)newVal2/wSum;
		            if(xSum>=0) xSum = (int)((float)xSum/wSum + H); 
		          	else xSum = (int)((float)xSum/wSum - H);
		          	if(ySum>=0) ySum = (int)((float)ySum/wSum + H); 
		          	else ySum = (int)((float)ySum/wSum - H);
		           
		          	dif0 = fNewVal0-mVal0; 
		          	if(mVal0 > 80) dif0 *= 2;
		          	dif1 = fNewVal1-mVal1; dif2 = fNewVal2-mVal2;
		          	distR2 = (dif0*dif0 + dif1*dif1 + dif2*dif2)/radiusR2+
		                   (xSum*xSum + ySum*ySum)/radiusD2;
		                   
		         	mVal0=fNewVal0; mVal1= fNewVal1; mVal2 = fNewVal2;
		          	newX += xSum; newY += ySum; 
		           
		         	if(distR2<0.01) break;
				}
		        genItCount+=loops;
		        
		      	if(mVal0 >= 0) newVal0 = (int)(mVal0+H); else newVal0 = (int)(mVal0-H);
		      	if(mVal1 >= 0) newVal1 = (int)(mVal1+H); else newVal1 = (int)(mVal1-H);
		      	if(mVal2 >= 0) newVal2 = (int)(mVal2+H); else newVal2 = (int)(mVal2-H);
		        if(newX < 0) newX += width_; else if(newX >= width_) newX -= width_;
		      	if(newY < 0) newY += height_; else if(newY >= height_) newY -= height_;
		      
		      	k = newY*width_+newX; 

	          	peakAddr_[0][center] = newX; 
	          	peakAddr_[1][center] = newY;

	          	if(peaks[k] == null)
	            {
	            	peaks[k] = new Vector(2);
	              	vectorSize = 0;
	            }
	          	else
	            	vectorSize = peaks[k].size();
	            
	          	boolean localFlag = true;
	          	for(i=0; i< vectorSize; i++)
	            {
	            	tempTab = (int [])(peaks[k].elementAt(i));
	              	if(tempTab[0] == newVal0 && tempTab[1] == newVal1 && tempTab[2] == newVal2)
	                {  
	                	localFlag = false; 
	                  	peakAddr_[2][center] = i;
	                  	break;
	                }
	            }
	          	if(localFlag)
	            {
	            	tempTab = new int[3];
	              	tempTab[0] = newVal0; tempTab[1] = newVal1; tempTab[2] = newVal2;
	              	peaks[k].addElement(tempTab);
	                peakAddr_[2][center] = vectorSize;
	              	genCounter_++;
	            }
			}
		}
      	//System.out.println("genItCount= "+genItCount);
      	//System.out.println("genCounter ->> "+genCounter_);
	    for(k = 0; k<nPixels_; k++)
	    {
	    	int x = peakAddr_[0][k];
	        int y = peakAddr_[1][k];
	        u = peakAddr_[2][k];
	        center = x+y*width_;
	        newImage_[k] = (short)((int[])peaks_[0][center].elementAt(u))[0];
		}
       	return newImage_;
	}


	public char convertToRGB(float final_T) {
      
		final float[][] RGB = { { 3.2405f, -1.5371f, -0.4985f },
			{-0.9693f,  1.8760f,  0.0416f },
			{ 0.0556f, -0.2040f,  1.0573f } 
		};
      	final float Yn = 1.0f;
      	final float Un_prime = 0.1978f;
      	final float Vn_prime = 0.4683f;
      	final float Lt = 0.008856f;
      	final int Lightness = (1<<3);
      	final int Ustar = (1<<4);
      	final int Vstar = (1<<5);
      	char[] TI = new char[3];
      
      
      	if (final_T < 0.1) {
			TI[0] = 0;
			TI[1] = 0;
			TI[2] = 0;
      	} else {
			float my_x, my_y, my_z;
			if(final_T < 8.0) {
	  			my_y = Yn * final_T / 903.3f;
			} else {
	  			my_y = Yn * (float) Math.pow((final_T + 16.0) / 116.0, 3);
			}
			float u_prime = final_T / (13 * final_T) + Un_prime;
			float v_prime = final_T / (13 * final_T) + Vn_prime;
	
			my_x = 9 * u_prime * my_y / (4 * v_prime);
			my_z = (12 - 3 * u_prime - 20 * v_prime) * my_y / (4 * v_prime);
	
			TI[0] = (char)
        		((RGB[0][0] * my_x + RGB[0][1] * my_y + RGB[0][2] * my_z) * 255);
			TI[1] = (char)
				((RGB[1][0] * my_x + RGB[1][1] * my_y + RGB[1][2] * my_z) * 255);
			TI[2] = (char)
	 			((RGB[2][0] * my_x + RGB[2][1] * my_y + RGB[2][2] * my_z) * 255);

			if(TI[0]>255) TI[0]=255;
			else if(TI[0]<0) TI[0]=0;
 
			if(TI[1]>255) TI[1]=255;
			else if(TI[1]<0) TI[1]=0;
		      
			if(TI[2]>255) TI[2]=255;
			else if(TI[2]<0) TI[2]=0;
		}
    	return TI[0];
	}
     
    
  	public short[] prepareResult(int width_,int height_,short newImage_[]) 
    {
    	int nPixels_=width_*height_;
      	int temp;
     	int k, pk, ind;
      	int posColms, u, j;
      	short segmImagePixels[] = new short[nPixels_];
      	char RGBdata_[]= new char [nPixels_];
      	int contour[] = new int[nPixels_];
      
      	for(k=0;k<nPixels_;k++) RGBdata_[k]=convertToRGB((float)newImage_[k]);
     
      		//Segmented Image
      	for ( k = 0; k < nPixels_; k++ ) {
	    	temp= 0xFF000000 | RGBdata_[k]<<16 | RGBdata_[k]<<8 | RGBdata_[k];
	    	segmImagePixels[k] = (short)temp;
        }
	return (segmImagePixels);
	}
 	
}
