package gridcomp.example.active.pi;

import gridcomp.log.Loggers;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.proactive.core.util.wrapper.DoubleWrapper;

public class MasterImpl implements Master, Collector, MasterAttributes, BindingController 
{
    private Worker clientItf;
    private int streamLength;
    private List<Double> results = new ArrayList<Double>();
    
    public static final Logger logger = Logger.getLogger(Loggers.EXAMPLES);
    
    public void run(int niter)
    {
        for (int i = 0; i < streamLength; i++)
            clientItf.pi(niter);
    }
    
    public DoubleWrapper get()
    {
        double re = 0.0;
        if (results.size() != streamLength)
        	re = -streamLength;
        else
        	for (Double d: results)
        		re += d;
        return new DoubleWrapper(re/streamLength);

    }

    public void collect(double res)
	{
		logger.info("Ricevuto item " + (results.size()+1) + " di " + streamLength);
		results.add(res);
	}
	
    public void setItems(int num) 
    {
    	streamLength = (num <= 0) ? 1 : num;
    }
    
    public int getItems()
    {
    	return streamLength;
    }
    
    public void bindFc(String clientItfName, Object serverItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (clientItfName.equals(Worker.ITF_NAME))
                clientItf = (Worker) serverItf;
        else
            throw new NoSuchInterfaceException(clientItfName);
    }

    public String[] listFc() 
    {
        return new String[]{ Worker.ITF_NAME };
    }

    public Object lookupFc(String clientItfName) throws NoSuchInterfaceException 
    {
        if (Worker.ITF_NAME.equals(clientItfName)) 
            return clientItf;
        throw new NoSuchInterfaceException(clientItfName);
    }
    
    public void unbindFc(String clientItfName) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (clientItfName.equals(Worker.ITF_NAME)) 
        	clientItf = null;
        else 
        	throw new NoSuchInterfaceException(clientItfName);
    }
}
