package gridcomp.example.passive.mandelbrot;

import java.util.Random;


import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.proactive.Body;
import org.objectweb.proactive.RunActive;

public class Input implements RunActive, BindingController 
{
    private Random rnd = new Random();
    public final static int delay = 10;
    public final static int dimension = 800;
    
    private int[] perm = new int[dimension];
    private LineServer lineserver = null;
    private boolean init = false;

    public Input()
    {    
        for (int i = 0; i < dimension; i++)
            perm[i]=i;
        for (int i = 0; i < dimension; i++) {
            int bak = perm[i];
            int index = rnd.nextInt(dimension);
            perm[i] = perm[index];
            perm[index] = bak;
        }
    }
    
    public void runActivity(Body arg0) 
    {    
        if (!init) {
            for (int i = 0; i < dimension; i++) {
                /*
                try {
                    Thread.sleep(delay);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                */
                lineserver.drawLine(i);
            }
            init = true;
        }
    }

    public void bindFc(String arg0, Object arg1) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (arg0.equals("lineserver-client"))
            lineserver = (LineServer) arg1;
        else 
            throw new NoSuchInterfaceException("No such interface named: "+arg0);
    }

    public String[] listFc() 
    {
        return new String[]{"lineserver-client"};
    }

    public Object lookupFc(String arg0) throws NoSuchInterfaceException 
    {
        if(arg0.equals("lineserver-client"))
            return lineserver;
        throw new NoSuchInterfaceException("No such interface named: "+arg0);
    }

    public void unbindFc(String arg0) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (arg0.equals("lineserver-client")) 
            lineserver = null;
        else 
            throw new NoSuchInterfaceException("No such interface named: "+arg0);
    }
}
