package gridcomp.example.passive.mandelbrot;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JComponent;

public class MandelbrotJComponent extends JComponent 
{
    private static final long serialVersionUID = -4558971246274900541L;

    private Color colorMatrix[][] = new Color[Input.dimension][Input.dimension];
    
    public void paintComponent(Graphics g) 
    {
        for (int i = 0; i < Input.dimension; i++) {
            for (int j = 0; j < Input.dimension; j++){
                Color color = colorMatrix[i][j];
                if (color != null) {
                    g.setColor(color);
                    g.fillRect(i, j, 1, 1);
                }
            }
        }
    }
    
    public void setColorMatrix(Color[][] matrix)
    {
        colorMatrix = matrix;
    }
}
