package gridcomp.example.passive.pi;

import gridcomp.farm.gui.JFarm;

import java.util.*;

import javax.swing.JFrame;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.util.Fractal;

import org.objectweb.proactive.api.PADeployment;
import org.objectweb.proactive.core.ProActiveException;
import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.descriptor.data.ProActiveDescriptor;

public class Main 
{
	// To use locally
	//public static int niter = 8 * 1024 * 1024;
	// To use on cannonau
	public static int niter = 2 * 1024 * 1024;
	public static JFarm farmGUI = null;
    
    public static void main(String[] args) throws Exception
    {   

	ProActiveDescriptor pad = setupProActive();
       

        Map<String, Object> context = new HashMap<String, Object>(1);
        context.put("deployment-descriptor", pad);
        
        
        Factory fact = gridcomp.adl.FactoryFactory.getFactory();
        
        Component root =  (Component) fact.newComponent("gridcomp.example.passive.pi.adl.root", context);
        Master itf = (Master)root.getFcInterface(Master.ITF_NAME);

        MasterAttributes ma = null;
        ContentController cc = (ContentController) root.getFcInterface(Constants.CONTENT_CONTROLLER);//, fcc = null;
        Component comps[] = cc.getFcSubComponents();
        Component farm = null;
        for (Component c: comps)
        	if (Fractal.getNameController(c).getFcName().equals("client")) {
        		ma  = (MasterAttributes)    c.getFcInterface(Constants.ATTRIBUTE_CONTROLLER);
                niter = ma.getItems();
        	} else if (Fractal.getNameController(c).getFcName().equals("farm")) {
        		farm = c;
        	}
        createGraphicalInterface(farm, "worker");

        Fractal.getLifeCycleController(root).startFc();
        System.out.println("The stream has length " + ma.getItems());
        System.out.println("Starting computation with " + niter + " operations...");

        itf.run(niter);
       
        // Active wait... no other workaround possible!
        double res = itf.get().doubleValue();
        while (res < 0) {
    		try { Thread.sleep(5000); } catch (InterruptedException _) {}
    		res = itf.get().doubleValue();
        }

        Fractal.getLifeCycleController(root).stopFc();
      
        System.exit(0);
    }
    private static ProActiveDescriptor setupProActive() throws ProActiveException
	{
		ProActiveDescriptor pad = null;
		   
    	Properties programProperties = System.getProperties();
        programProperties.setProperty("java.security.manager", new String());
        programProperties.setProperty("java.security.policy", "proactive.java.policy");
        programProperties.setProperty("fractal.provider", "org.objectweb.proactive.core.component.Fractive");
        programProperties.setProperty("log4j.configuration", "file:proactive-log4j");
      //  programProperties.setProperty("deployment.descriptor", "local-deployment.xml");
        System.setProperties(programProperties);
     
        System.setProperties(programProperties);
        pad = PADeployment.getProactiveDescriptor(System.getProperty("deployment.descriptor"));
		System.out.println("Loaded " + System.getProperty("deployment.descriptor"));
		pad.activateMappings();
		return pad;
	}
    private static void createGraphicalInterface(Component owner, String name)
    {
        JFrame frame = new JFrame("Autonomic Behavior Controller");
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        frame.setResizable(false);
        
        farmGUI = new JFarm(owner, name, true);
        frame.getContentPane().add(farmGUI);
        frame.pack();
        frame.setVisible(true);
    }

}
