package gridcomp.example.passive.pi;

import java.util.Random;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;


public class WorkerImpl implements Worker, BindingController 
{    
    public static Random rand = new Random(35791246);
    
    private Collector clientItf = null;

    public void pi(int niter)
    {
    	long start = System.currentTimeMillis();
        double x,y,z;
        int count = 0; /* # of points in the 1st quadrant of unit circle */
        
        for (int i = 0; i < niter; i++) {
           x = rand.nextDouble();
           y = rand.nextDouble();
           z = x*x + y*y;
           if (z <= 1) 
        	   count++;
        }
        start -= System.currentTimeMillis();
        System.out.println("Worker: required " + (-start) + " milliseconds...");
        clientItf.collect((double)count/niter*4);
    }
    
    public void bindFc(String clientItfName, Object serverItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (clientItfName.equals(Collector.ITF_NAME))
                clientItf = (Collector) serverItf;
        else
            throw new NoSuchInterfaceException(clientItfName);
    }

    public String[] listFc() 
    {
        return new String[]{ Collector.ITF_NAME };
    }

    public Object lookupFc(String clientItfName) throws NoSuchInterfaceException 
    {
        if (Collector.ITF_NAME.equals(clientItfName)) 
            return clientItf;
        throw new NoSuchInterfaceException(clientItfName);
    }
    
    public void unbindFc(String clientItfName) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (clientItfName.equals(Collector.ITF_NAME)) 
        	clientItf = null;
        else 
        	throw new NoSuchInterfaceException(clientItfName);
    }
}
