package gridcomp.example.statefulmap.impl;
/*
 * - farm migliorato/ingegn.to
 * - map con un esempio che giri x mercoledi 16 aprile ore 15.00
 * */
import gridcomp.map.Task;
import gridcomp.map.port.MulticastTestItf1;
import gridcomp.map.port.MulticastTestItf2;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Random;
import java.util.StringTokenizer;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.api.PADeployment;
import org.objectweb.proactive.core.descriptor.data.ProActiveDescriptor;

public class Main{
	private static final long serialVersionUID = 1L;


	public static void main(String[] args) throws NoSuchInterfaceException, Exception {
		Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
		Map context = new HashMap();

		String actualtestcase = "";
		int p = 60;

		System.out.println("///////////////////////////////////////////////////////////");
		System.out.println(" Runnning on a dataset of "+p+" tasks......................");
		System.out.println("///////////////////////////////////////////////////////////");
		System.out.println("[Main] Deploying the application..................................");

		// testcase with no gathering interfaces 
		// context.put("worker", "doublemulticast.adl.server");
		actualtestcase = new String("gridcomp.example.statefulmap.adl.testcase");
		String padPath = args[1];
		ProActiveDescriptor pad = PADeployment.getProactiveDescriptor(padPath);
		context.put("deployment-descriptor", pad);
		
		//context.put("worker", "gridcomp.example.statefulmap.adl.worker");
		context.put("worker", args[2]);
		context.put("rulespath", args[0]);
		context.put("padPath", padPath);
		
		Component testcase = (Component) f.newComponent(actualtestcase,context);
		System.out.println("[Main] Start the application..................................");

		Fractal.getLifeCycleController(testcase).startFc();

		/* map canonica */

		MulticastTestItf1 root1 = (MulticastTestItf1) testcase.getFcInterface("runTestItf-01");
		MulticastTestItf2 root2 = (MulticastTestItf2) testcase.getFcInterface("runTestItf-02");
		//int numworker = ((ContentController)testcase.getFcInterface("content-controller")).getFcSubComponents().length-1;
		int numworker = get_workers(testcase);
		List<Task> ts = getParam(p,false);
		System.out.println("[Main] Partitioning "+ts.size()+" tasks to "+numworker+" workers....");
		root1.getService(ts);
		System.out.println("[Main] End partitioning....");
		
		boolean trovato=false;
		do{
			ts = getParam(p,true);
			List<Task> name=null; 
			System.out.println("\n======= [Main] Search match for item "+ts.get(0).getObject()+"=======");
			name = root2.searchMatch(ts); 
			trovato=checkresult(name,ts.get(0));
			if (trovato)
				System.out.println("\n======= [Main] Item FOUND =======\n");
			else
				System.out.println("\n======= [Main] Item NOT found =======\n");
		}while(true);

		//System.out.println("End of computation...........");
	}

	private static int get_workers(Component testcase)  {
		Component map=null;
		ContentController cc = null;
		try {
			map = ((ContentController)testcase.getFcInterface("content-controller")).getFcSubComponents()[0];
			cc = (ContentController) map.getFcInterface("content-controller");
			
		} catch (NoSuchInterfaceException e) {
			e.printStackTrace();
		}
		
		return cc.getFcSubComponents().length-1;
	}

	private static boolean checkresult(List<Task> name, Task task) {
		if ((name==null) || (name.size()==0)){
			System.err.println("[Main]>>>>>>>>>> Application failed <<<<<<<<<<<<<");
			System.exit(0);
		}
		String t;
		StringTokenizer st;
		boolean trovato=false;
		//System.out.println("\n======= [Main] Checking the result.......\n");
		for (int i=0;i<name.size();i++){
			t = (String)name.get(i).getObject();
			if (t.endsWith("OK"))
				trovato = true;
			st = new StringTokenizer(t,"\t");
			String worker_res = st.nextToken();
			System.out.println("[WORKER"+i+worker_res.substring(7, worker_res.length()-1));
			//System.out.println("seconda parte = "+st.nextToken());
			
		}
//		System.out.println("\n======= [Main] End checking of the result.......\n");
		return trovato;
			
	}


	private static List<Task> getParam(int n, boolean broadcast){
		List<Task> ts = new ArrayList<Task>();
		Random rand = new Random();
		int v = (Math.abs(rand.nextInt()))%n;
		for (int i=0;i<n;i++){
			if (broadcast)
				ts.add(new Task(new Integer(v)));
			else
				ts.add(new Task(new Integer(i)));

		}  
		return ts;	

	}
}
