package gridcomp.example.statefulmap.impl;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.List;
import java.util.Vector;

import org.apache.log4j.Logger;
//import gridcomp.log.Loggers;
import gridcomp.map.Task;
import gridcomp.map.controller.operation.ReconfigSupport;


public class ServerImpl implements ServerTestItf1, ServerTestItf2, ReconfigSupport{
	//private static int IDgenerator=0;
	//private int myid;
	private Vector<Task> mypiece=new Vector<Task>();        
	private String hostname=null;
	
	private static final Logger logger = Logger.getLogger("");

	public ServerImpl(){
		//myid= IDgenerator++;
		try {
			hostname = InetAddress.getLocalHost().getHostName();
		} catch (UnknownHostException e) {
			e.printStackTrace();
		}
	}
	public synchronized Task getService(Task a) {
		// questa e' una funzione di accumulazione/wrapper dei task
		mypiece.clear();
		if (a.isPrimitive()){
			Integer itg = (Integer)a.getObject();
			int v =  itg.intValue();
			mypiece.add(a);
			//logger.warn("[WORKER-"+myid+" on "+hostname+"] Received PRIMITIVE entry: "+v);
			logger.warn("[WORKER on "+hostname+"] Received PRIMITIVE entry: "+v);
		}else{
			// a contains a List implementation
			//System.out.println("[WORKER-"+myid+"] Receiving a partition of size "+a.size());

			List partition =  (List) a.getObject();
			for (int i=0;i<partition.size();i++){
				Task tt = (Task) partition.get(i);
				mypiece.add(tt);
			}
			//System.out.print("[WORKER-"+myid+" on "+hostname+"] Receiving partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]\n");
		}
		return null;
	}

	public String printPiece(int s){
		//String s2 = "[WORKER-"+myid+" on "+hostname+"] Search task "+s+" in partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]\n";
		String s2 = "[WORKER on "+hostname+"] Search task "+s+" in partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]\n";
		//System.out.print(s2);
		return s2;
	}
	public synchronized Task searchMatch(List<Task> tsl){
		/* The worker receives a List (of size 1) of Task (the fingerprint to look for)
		 */
		//System.out.println("[ServerImpl-"+myid+"] starts searching on "+tsl.size()+" values");
		Task ts = tsl.get(0);
		int s = ((Integer)ts.getObject()).intValue();
		String res;
		boolean found=false;
		String msg = printPiece(s);
		long init = System.currentTimeMillis();
		if (mypiece.size()==0){
			//logger.warn("[WORKER-"+myid+" on "+hostname+"] void status!");
			logger.warn("[WORKER on "+hostname+"] void status!");
		}else{
			int i=0;
			int v;
			
			do{
				v = ((Integer)((Task)mypiece.get(i)).getObject()).intValue();
				if (s==v)
					// match found!
					found=true;
				//java.util.Random r = new java.util.Random();
				//double iteration=100000*(r.nextInt()%10);
				//double iteration=100000*mypiece.size();
				double iteration=mypiece.size();
				//double _sin=0,_ctg=0;
				//double max=0;
				DelayValue dv = new DelayValue();
				dv.profile(100);
				//for (int j=0;j<iteration;j++)
					dv.delay(new Long(mypiece.size()));
					/*
					_sin = Math.sin(iteration%r.nextInt());
					_ctg = Math.cosh(iteration%r.nextInt());
					if (max<Math.max(_sin, _ctg))
						max = Math.max(_sin, _ctg);*/
				i++;
				}while(i<mypiece.size() && !found);
			}
			long ending = System.currentTimeMillis();
			if (found){
				//res = msg+"\t[WORKER-"+myid+"]-OK";
				res = msg+"\t[WORKER t="+(ending-init)+"]-OK";
			}else
				//res = msg+"\t[WORKER-"+myid+"]-KO";
				res = msg+"\t[WORKER t="+(ending-init)+"]-KO";
			//System.out.println(res);	
			logger.info(res);
			return new Task(res);
		}

	private class DelayValue {
		double classFactor = 3000.0;
		public void profile(int ms){
				long t0 = System.currentTimeMillis();
				int factor = 50000;
				for(int i=0;i<Integer.MAX_VALUE/factor;i++){
				    Math.sin(Math.cos(Math.sqrt(i+0.0)));
				}
				long timespent = System.currentTimeMillis() - t0;
				classFactor = (factor*timespent)/(ms+0.0);
			}
		public void delay(long ttw) {
			//m.profile(100);
			long t0 = System.currentTimeMillis();
			while(System.currentTimeMillis() - t0 < ttw)
				for(int i=0;i<Integer.MAX_VALUE/classFactor;i++)
					Math.sin(Math.cos(Math.sqrt(i+0.0)));
						
		}
	}
	
	
		public void setStatus(List<Task> tsl){
			// the status has been modified
			//logger.warn("[WORKER-"+myid+" on "+hostname+"] updating the state from the controller....");
			logger.warn("[WORKER on "+hostname+"] updating the state from the controller....");
			mypiece.clear();
			for (int i=0;i<tsl.size();i++){
				mypiece.add(tsl.get(i));
			}
			//      System.out.println("[ServerImpl]-"+myid+"]  end setting a new state  <----------");
		}
		public List<Task> provideStatus(){
			// the status must be provided outside
			//logger.warn("[WORKER-"+myid+" on "+hostname+"] providing the state to the controller...");
			logger.warn("[WORKER on "+hostname+"] providing the state to the controller...");
			return mypiece;
		}
		public String setStatusAndReply(List<Task> tsl) {
			this.setStatus(tsl);
			//String ret = new String("[WORKER-"+myid+" on "+hostname+"] updating, new partition with ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]\n");
			String ret = new String("[WORKER on "+hostname+"] updating, new partition with ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]\n");
			return ret;
		}


}