package gridcomp.example.statelessmap.impl;

import gridcomp.map.Task;
import gridcomp.map.port.MulticastTestItf2;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.StringTokenizer;


import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;


public class FingerPrintImpl implements FingerPrint,BindingController {
	MulticastTestItf2 clientItf;
	Redistribute prod;
	
	private boolean stop=false;
	private List<Task> getFingerList(int n){
		/* creates an hypotetic fingerprint to be searched
		 * */
		Random r = new Random();
		int v = Math.abs(r.nextInt())%n;
		System.out.println("------- [FingerPrint] Ask for recognition of item "+v+" -------");
		List<Task> ts = new ArrayList<Task>();
		ts.add(new Task(new Integer(v)));
		return ts;
	}
	public void stop(){
		stop = true;
	}
	public void start(int dbsize){
		stop = false;
		do{
			List<Task> fingerprint = getFingerList(dbsize);
			List<Task> res = clientItf.searchMatch(fingerprint);
			checkAnsweres(res);	
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}while(!stop);
		
	}
	private boolean reconf_state = false;
	
	private void checkAnsweres(List<Task> res) {
		boolean found=false;
		boolean reconf=false;
		String comment=new String();
		for (int i=0;i<res.size();i++){
			String msg = (String)(res.get(i).getObject()); 
			//System.out.println(">>>>>>>>>>>>"+msg);
			if (msg.endsWith("yet")){
				reconf=true;
				comment = new String(" and redistribution needed!");
			}if (msg.endsWith("ok"))
				found=true;
			StringTokenizer token = new StringTokenizer(msg,"_");
			System.out.println(token.nextToken());
		}
		
		if (found)
			System.out.println("\n[FingerPrint] Item FOUND "+comment+"! \n");
		else
			System.out.println("\n[FingerPrint] Item NOT FOUND "+comment+"! \n");

		if (!reconf)
			reconf_state =false;
		else{
			if (!reconf_state){
				prod.redistribute();
			}else
				System.out.println("\n[FingerPrint] Waiting for redistribution............");
		}
	}
	public void bindFc(String clientItfName, Object serverItf)
			throws NoSuchInterfaceException, IllegalBindingException,
			IllegalLifeCycleException {

		if (clientItfName.equals("clientItf")) {
				clientItf = (MulticastTestItf2) serverItf;
		}
		else {
			if (clientItfName.equals("redistribute"))
				prod = (Redistribute) serverItf;
			else
				throw new NoSuchInterfaceException(clientItfName);
		}
	}
	public String[] listFc() {
		return null;
	}

	public Object lookupFc(String clientItfName)
			throws NoSuchInterfaceException {

		if ("clientItf".equals(clientItfName)) {
			return clientItf;
		}
		if ("redistribute".equals(clientItfName)) {
			return prod;
		}
		throw new NoSuchInterfaceException(clientItfName);
		
	}
	public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
			IllegalBindingException, IllegalLifeCycleException {
		if ("clientItf".equals(clientItfName)) {
			clientItf=null;
		}
		if ("redistribute".equals(clientItfName)) {
			prod=null;
		}
		throw new NoSuchInterfaceException(clientItfName);
		
	}
	

}
