package gridcomp.example.statelessmap.impl;

import gridcomp.map.Task;
import gridcomp.map.port.MulticastTestItf1;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;


public class ProducerImpl implements Producer, Redistribute, BindingController{
	//private Vector<String> dummyDB;
	MulticastTestItf1 clientItf;
	FingerPrint fp;
	private int dbsize;
	private List<Task> dummyDB;
	
	private void createDB(int n){
		dummyDB = new ArrayList<Task>();
		for (int i=0;i<n;i++){
			dummyDB.add(i, new Task(new Integer(i)));
		}
	}
	public void startApp(int _num, int partition) {
		dbsize=_num;
		createDB(dbsize);
		// simply split the DB, it does not need an return type
		clientItf.getService(dummyDB);
		List<Task> lt = clientItf.getService(dummyDB);
		for (int i=0;i<lt.size();i++){
			System.out.println((String)lt.get(i).getObject());
		}
		System.out.println("\n[ProducerImpl] End partitioning of "+dummyDB.size()+" items onto "+partition+" workers!\n");
		fp.start(dbsize);
		// here we needs to weak up the fingerprint
	}
	public void bindFc(String clientItfName, Object serverItf)
			throws NoSuchInterfaceException, IllegalBindingException,
			IllegalLifeCycleException {

		if (clientItfName.equals("initItf")) {
				clientItf = (MulticastTestItf1) serverItf;
		}
		else {
			if (clientItfName.equals("startfinger")) {
				fp = (FingerPrint) serverItf;
			}else
				throw new NoSuchInterfaceException(clientItfName);
		}
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#listFc()
	 */
	public String[] listFc() {
		
		return null;
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#lookupFc(java.lang.String)
	 */
	public Object lookupFc(String clientItfName)
			throws NoSuchInterfaceException {

		if ("initItf".equals(clientItfName)) {
			return clientItf;
		}else		
			if ("startfinger".equals(clientItfName)) {
				return fp;
			}else throw new NoSuchInterfaceException(clientItfName);
		
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#unbindFc(java.lang.String)
	 */
	public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
			IllegalBindingException, IllegalLifeCycleException {

		// TODO Auto-generated method stub

	}
	public void redistribute() {
		//numpartition++;
		List<Task> lt = clientItf.getService(dummyDB);
		for (int i=0;i<lt.size();i++){
			System.out.println((String)lt.get(i).getObject());
		}
		System.out.println("\n************** [ProducerImpl] End redistributing "+dummyDB.size()+" items **************");
		fp.start(dbsize);
	}



}
