package gridcomp.example.statelessmap.impl;
import gridcomp.map.Task;
import gridcomp.map.controller.operation.ReconfigSupport;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.List;
import java.util.Vector;

public class ServerImpl implements ServerTestItf1, ServerTestItf2, ReconfigSupport{
    private static int IDgenerator=0;
    private int myid;
	private Vector<Task> mypiece= new Vector<Task>();
	private String hostname=null;
	public ServerImpl(){
		myid = IDgenerator++;
		try {
			hostname = InetAddress.getLocalHost().getHostName();
		} catch (UnknownHostException e) {
			e.printStackTrace();
		}
	}
	
	public Task getService(Task a) {
		Task toreturn;
		mypiece.clear();
		if (a.isPrimitive()){
			Integer itg = (Integer)a.getObject();
			int v =  itg.intValue();
			mypiece.add(a);
			//System.out.println("[WORKER-"+myid+"] Received PRIMITIVE entry: "+v);
			toreturn = new Task(new String("[WORKER-"+myid+"] Received PRIMITIVE entry: "+v));
		}else{
			// a contains a List implementation
			//System.out.println("[WORKER-"+myid+"] Receiving a partition of size "+a.size());
			//System.out.print("[WORKER-"+myid+"] Receiving partition [");
			
			List partition =  (List) a.getObject();
			for (int i=0;i<partition.size();i++){
				Task tt = (Task) partition.get(i);
				mypiece.add(tt);
				//if (i<(partition.size()-1))
				//	System.out.print(tt.getObject()+", ");
				//else
				//	System.out.println(tt.getObject()+"]");
			}
			String s2 = "[WORKER-"+myid+" on "+hostname+"] Receiving partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]\n";
			toreturn = new Task(s2);
 		}
		return toreturn;
	}
	private void showpartition(int v){
   		System.out.print("[WORKER-"+myid+"] Holder of partition [");
       	for (int i=0;i<mypiece.size();i++)
       		System.out.print((Integer)mypiece.get(i).getObject()+",");
       	System.out.println("] search for item "+v);
	}
	
	public Task searchMatch(List<Task> tsl){
//		System.out.println("[ServerImpl-"+myid+"] starts searching on "+tsl.size()+" values");
		Task toreturn;
		if (mypiece.size()==0){
			//System.out.println("[WORKER-"+myid+"] no tasks to compute, yet");
			toreturn= new Task(new String("[WORKER-"+myid+"] no tasks to compute, yet"));
		}else{
			Task ts = tsl.get(0);
			int s = ((Integer)ts.getObject()).intValue();
			//showpartition(s);
			int i=0;
			String res=new String("[WORKER-"+myid+" on "+hostname+"] Search task "+s+" in partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]");
			boolean found=false;
			do{
				Task t = (Task)mypiece.get(i);
				Integer it = (Integer)t.getObject(); 
				int v = it.intValue();
				if (s==v){
					res.concat("_ok");
					found=true;
				}else
					res.concat("_ko");
				i++;
			}while(i<mypiece.size() && !found);
			toreturn =  new Task(res);
		}
		return toreturn;
	}

	public List<Task> provideStatus() {
		return null;
	}

	public void setStatus(List<Task> tsl) {}
	public String setStatusAndReply(List<Task> tsl) {
		return null;}

}
