package gridcomp.example.statelessmap.impl;
import gridcomp.map.Task;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.List;
import java.util.Vector;

import org.apache.log4j.Logger;
public class SimpleServerImpl implements ServerTestItf1, ServerTestItf2{
    private static int IDgenerator=0;
    private int myid;
	private Vector<Task> mypiece= new Vector<Task>();
	private String hostname=null;
	private static final Logger logger = Logger.getLogger("");

	public SimpleServerImpl(){
		myid = IDgenerator++;
		try {
			hostname = InetAddress.getLocalHost().getHostName();
		} catch (UnknownHostException e) {
			e.printStackTrace();
		}

	}
	
	public Task getService(Task a) {
		Task toreturn;
		mypiece.clear();
		if (a.isPrimitive()){
			Integer itg = (Integer)a.getObject();
			int v =  itg.intValue();
			mypiece.add(a);
			toreturn = new Task(new String("[WORKER-"+myid+" on "+hostname+"] Received PRIMITIVE entry: "+v));
		}else{
			// a contains a List implementation
			//System.out.println("[WORKER-"+myid+"] Receiving a partition of size "+a.size());
		
			List partition =  (List) a.getObject();
			for (int i=0;i<partition.size();i++){
				Task tt = (Task) partition.get(i);
				mypiece.add(tt);
			}
			//System.out.print("[WORKER-"+myid+" on "+hostname+"] Receiving partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]\n");
			toreturn = new Task(new String("[WORKER-"+myid+" on "+hostname+"] Receiving partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]"));
 		}
		return toreturn;
	}
	private void showpartition(int v){
   		logger.warn("[WORKER-"+myid+" on "+hostname+"] Holder of partition [");
       	for (int i=0;i<mypiece.size();i++)
       		if (i<(mypiece.size()-1))
       			logger.warn((Integer)mypiece.get(i).getObject()+",");
       		else
       			logger.warn((Integer)mypiece.get(i).getObject());
       	logger.warn("] search for item "+v);
	}
	
	public Task searchMatch(List<Task> tsl){
//		System.out.println("[ServerImpl-"+myid+"] starts searching on "+tsl.size()+" values");
		String msg=null;
		if (mypiece.size()==0){
			msg = new String("[WORKER-"+myid+" on "+hostname+"] no tasks to compute, yet");
		}else{
			Task ts = tsl.get(0);
			int s = ((Integer)ts.getObject()).intValue();
			int i=0;
			int v;
			String res;
			boolean found=false;
			msg=new String("[WORKER-"+myid+" on "+hostname+"] Search task "+s+" in partition ["+mypiece.get(0).getObject()+"-"+mypiece.get(mypiece.size()-1).getObject()+"]");

			do{
				v = ((Integer)((Task)mypiece.get(i)).getObject()).intValue();
				if (s==v){
					// match found!
					found=true;
				}
				java.util.Random r = new java.util.Random();
				double iteration=100000*(r.nextInt()%10);
				double _sin=0,_ctg=0;
				double max=0;
				for (int j=0;j<iteration;j++){
					_sin = Math.sin(iteration%r.nextInt());
					_ctg = Math.cosh(iteration%r.nextInt());
					if (max<Math.max(_sin, _ctg))
						max = Math.max(_sin, _ctg);
				}
				i++;
			}while(i<mypiece.size() && !found);
			
			if (found)
				msg = new String(msg+"_ok");
				
			else
				msg = new String(msg+"_ko");
			//System.out.println(res);	
			
		}
		return new Task(msg);
	}
}