package gridcomp.manager.operations;


import gridcomp.controller.AutonomicController;
import gridcomp.controller.BeskeAttributeController;
import gridcomp.operation.FarmAddWorker;
import gridcomp.log.Loggers;

import java.io.File;
import java.io.FilenameFilter;
import java.util.concurrent.ConcurrentLinkedQueue;

import org.apache.log4j.Logger;

public class FarmAddExecutorCommand implements ManagerCommand {

	private String adl;
	private String xml;
	private static int i = 1;
	private AutonomicController abc;
	private BeskeAttributeController bac;
	public static final String NAME_PREFIX = "slave-1";
	private int MAX_ADL = 25;
    // MarcoA MAX_ADL deve essere settato al numero di file adl nella directory slaves
	private ConcurrentLinkedQueue<String> workerNamesReference;
	private Logger logger = Logger.getLogger(Loggers.MANAGER);
	private Object data = null;
	
	public FarmAddExecutorCommand(AutonomicController abc, BeskeAttributeController bac, ConcurrentLinkedQueue<String> workerNames)
	{
		this.abc = abc;
		this.bac = bac;
		this.workerNamesReference = workerNames;
		
		String dirPath = bac.getProperty("adl.dir");
		File dir = new File(dirPath);
		if (dir.exists())
		{
		FilenameFilter filter = new FilenameFilter() {
			public boolean accept(File dir, String name) {
			return name.endsWith(".fractal");
			}

			};
			String names[] = dir.list(filter);
			MAX_ADL = names.length;
		}

	}
	
	public void execute() {
		
	
			if(data != null) {
			
			String[] adlArray = new String[(Integer)data];
			String[] xmlArray = new String[(Integer)data];
			String[] nameArray = new String[(Integer)data];
			
			
			for(int j=0;j<(Integer)data;j++) {
				
				adlArray[j] = bac.getProperty("adl.dir").replace('/', '.') + ".slave-" + i;
				xmlArray[j] = bac.getProperty("xml.file");
				nameArray[j] = "slave-" + i;
				++i;
				
				if (i > MAX_ADL)
					i = 1;
				// I put workerName to a queue in order to remove it later
				workerNamesReference.add(nameArray[j]);
			}
			
			abc.execOperation(FarmAddWorker.OPNAME, adlArray, xmlArray, nameArray);
			logger.info("Executing AddWorker: adding workers with named " + nameArray);
		}
		else{
		
			adl = bac.getProperty("adl.dir").replace('/', '.') + ".slave-" + i;
			xml = bac.getProperty("xml.file");
			String workerName = "slave-" + i;
			++i;
			
			if (i > MAX_ADL)
				i = 1;
			// I put workerName to a queue in order to remove it later
			workerNamesReference.add(workerName);
			abc.execOperation(FarmAddWorker.OPNAME, adl, xml, workerName);
			logger.info("Executing AddWorker: adding worker with name " + workerName + " MAX:"+MAX_ADL);
		}

		data = null;
	}
	
	public void setData(Object data) {
		this.data = data;
	}
	
	public Object getData() {
	
		return this.data;
	}

}
