package gridcomp.manager.operations;

import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.logging.Logger;

import gridcomp.controller.AutonomicController;
import gridcomp.operation.FarmSubWorker;

public class FarmSubExecutorCommand implements ManagerCommand {
	private AutonomicController abc;
	private ConcurrentLinkedQueue<String> workerNameReference;
	private Logger logger = Logger.getLogger(FarmAddExecutorCommand.class.getName());
	private Object data;
	public FarmSubExecutorCommand(AutonomicController managedAutonomicController, ConcurrentLinkedQueue<String> workerNames) {
		this.abc = managedAutonomicController;
		this.workerNameReference = workerNames;
	}
	public void execute() {
		String workerName;
		if ((workerName = workerNameReference.poll())!= null)
		{
			logger.info("Removing component worker named " + workerName);
			
			String[] ops = abc.listAutonomicOperations();
			
			for(String s : ops){
				System.out.println("OPERATION: "+s);
			}
			
			abc.execOperation(FarmSubWorker.OPNAME, workerName);	
		} else
		{
			logger.info("FarmSubExecutorCommand failed!");
		}

	}
	public void setData(Object data) {
		this.data  = data;
	}
	public Object getData() {
		// TODO Auto-generated method stub
		return this.data;
	}

}
