package gridcomp.operation;

import org.apache.log4j.Logger;

import gridcomp.AutonomicException;
import gridcomp.controller.AutonomicController;
import gridcomp.controller.KnowledgeConstants;
import gridcomp.log.Loggers;

public class FarmNumWorkers extends AbstractAutonomicOperation
{
    public static String OPNAME = "getNumWorkers";
    private static final Logger logger = Logger.getLogger(Loggers.OPERATION);
    
    public FarmNumWorkers(AutonomicController ac)
    {
        super(ac);
    }
    
    public void checkContext() throws AutonomicException
    {
        if (owner.getKnowledge().get(KnowledgeConstants.NUM_WORKERS) == null)
            throw new AutonomicException("The number of workers has not been set during FarmNumWorker::checkContext()!");
        logger.info("FarmNumWorker::Context successfully checked.");
    }

    @Override
    public Object exec(Object... params) throws AutonomicException
    {
        Integer result = (Integer) owner.getKnowledge().get(KnowledgeConstants.NUM_WORKERS);
        return result;
    }
}
