package gridcomp.test;

import gridcomp.log.Loggers;

import org.apache.log4j.Logger;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.proactive.core.util.wrapper.IntWrapper;

public class MasterImpl implements I, Getter, Runner, BindingController 
{
    private I next;
    private int results = 0, void_count = 1;
    
    public static final Logger logger = Logger.getLogger(Loggers.TEST);
    
    public void run() 
    {
        logger.info("Master::void::start (" + void_count + ")");
        /*
        try {
            Thread.sleep(1000);
        } catch (InterruptedException _) {}
        */
        next.voidCall();
        logger.info("Master::void::end (" + void_count++ + ")");
    }
    
    public void bindFc(String clientItfName, Object serverItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (I.ITF_CLIENT_NAME.equals(clientItfName))
            if (serverItf instanceof I)
                next = (I) serverItf;
            else
                throw new IllegalBindingException(clientItfName);
        else
            throw new NoSuchInterfaceException(clientItfName);
    }

    public String[] listFc() 
    {
        return new String[] { I.ITF_CLIENT_NAME };
    }

    public Object lookupFc(String clientItfName) throws NoSuchInterfaceException 
    {
        if (I.ITF_CLIENT_NAME.equals(clientItfName))
            return next;
        throw new NoSuchInterfaceException(clientItfName);
    }

    public void unbindFc(String clientItfName) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (I.ITF_CLIENT_NAME.equals(clientItfName))
            next = null;
        else
            throw new NoSuchInterfaceException(clientItfName);
    }
    
    
    public IntWrapper get()
    {
        return new IntWrapper(results);
    }

    public void voidCall()
	{
    	results++;
	}
}
