package gridcomp.test;

import gridcomp.log.Loggers;

import org.apache.log4j.Logger;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;

public class Worker implements I, BindingController
{
    private static final Logger logger = Logger.getLogger(Loggers.OPERATION_TEST);
    private I collector = null;
    private static int void_count = 1;

    public synchronized void voidCall() 
    {
        logger.info("Worker::void::start (" + void_count + ")");
        try {
            Thread.sleep(1000);
        } catch (InterruptedException _) {}
        collector.voidCall();
        logger.info("Worker::void::end (" + void_count++ + ")");
    }
    
    public void bindFc(String clientItfName, Object serverItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (I.ITF_CLIENT_NAME.equals(clientItfName))
            if (serverItf instanceof I)
                collector = (I) serverItf;
            else
                throw new IllegalBindingException(clientItfName);
        else
            throw new NoSuchInterfaceException(clientItfName);
    }

    public String[] listFc() 
    {
        return new String[] { I.ITF_CLIENT_NAME };
    }

    public Object lookupFc(String clientItfName) throws NoSuchInterfaceException 
    {
        if (I.ITF_CLIENT_NAME.equals(clientItfName))
            return collector;
        throw new NoSuchInterfaceException(clientItfName);
    }

    public void unbindFc(String clientItfName) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
    {
        if (I.ITF_CLIENT_NAME.equals(clientItfName))
            collector = null;
        else
            throw new NoSuchInterfaceException(clientItfName);
    }

}
