package gridcomp.manager.beans;

import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

import gridcomp.manager.AbstractAutonomicManager;
import gridcomp.manager.operations.ManagerOperation;

public abstract class AbstractQoSItemBean<T> implements QoSItemBean<T> {
	protected AbstractAutonomicManager manager;
	protected String monitoringInteface;
	protected Object data;
	public void fireOperation(ManagerOperation op) {
		QoSEvent ev = new QoSEvent(op);
		ev.setData(data);
		manager.sendEvent(new GenericTypeWrapper<QoSEvent>(ev));
		
	}
	
	public void setData(Object data)
	{
		this.data = data;
	}
	public Object getData()
	{
		return data;
	}
	public abstract String getMonitoringInteface();
	public abstract void setMonitoringInteface(String s);
	public abstract T getValue();
	public abstract void setValue(T item);
	
}
