package gridcomp.manager.gui;

import javax.swing.SwingUtilities;

import org.jfree.data.DomainOrder;
import org.jfree.data.xy.AbstractXYDataset;

public class ManagerXYDataset extends AbstractXYDataset
{
    double[] xValues_ = new double[1];
    double[] yValues_ = new double[1];
    
    public ManagerXYDataset()
    {
    	xValues_[0] = 0.0;
    	yValues_[1] = 0.0;
        
        // A thread to update the model every 2 seconds
                    // We have to actually update the model values in the event thread
                    // to make sure that they are consistent. This is a quick operation
                    // becuase all we are doing is updating the references to the data arrays.
               
           
    }
    public double[] getXValues()
    {
    	return xValues_;
    }
    public double[] getYValues()
    {
    	return yValues_;
    }
    public void updateDataSet(double[] xValues, double[] yValues)
    {
    	xValues_ = xValues;
    	yValues_ = yValues;
        SwingUtilities.invokeLater(new Runnable()
        {
            public void run()
            {
                
                // So now we tell all the listeners that the
                // model has bee updated.
                fireDatasetChanged();
            }
        });

    }
    public DomainOrder getDomainOrder()
    {
        return DomainOrder.ASCENDING;
    }
    
    public double getXValue(int series, int item)
    {
        return xValues_[item];
    }
    
    public double getYValue(int series, int item)
    {
        return yValues_[item];
    }
    
    public int getSeriesCount()
    {
        return 1;
    }
    
    public Comparable getSeriesKey(int series)
    {
        return "Throughtput";
    }
    
    public Number getX(int series, int item)
    {
        return new Double(getXValue(series, item));
    }
    
    public Number getY(int series, int item)
    {
        return new Double(getYValue(series, item));
    }
    
    public int getItemCount(int series)
    {
        return xValues_.length;
    }
    public static ManagerXYDataset createDataSet()
    {
    	return new ManagerXYDataset();
    }
    
}


