package gridcomp.manager.gui;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.Socket;

public class RequestHandler implements Runnable {
	private Socket socket;
	private ManagerMonitorModel model;
	
	public RequestHandler(Socket socket, ManagerMonitorModel monitor)
	{
		this.socket = socket;
		this.model = monitor;
	}
	public void run() 
	{
		
        InputStream is;
		try {
			is = socket.getInputStream();
		
        BufferedReader br = new BufferedReader(
          new InputStreamReader(is, "US-ASCII"));
        String line = null;
        int workers = 0;
        long time = 0;
        double rate = 0;
        String methodName = "";
      
        while ((line = br.readLine()) != null) {
          System.out.println(line);
        	String[] values = line.split("#");
          int i = 0;
          for (String value: values)
          {
        	  String[] tmp = value.split(":");
        	  if (tmp.length == 2)
        	  {
        		  if (tmp[0].trim().equals("method"))
        			  methodName = tmp[1];
        		  if (tmp[0].trim().equals("time"))
        			  time = Long.parseLong(tmp[1]);
        		  if (tmp[0].trim().equals("rate"))
        			  rate = Double.parseDouble(tmp[1]);
        		  if (tmp[0].trim().equals("workers"))
        			  workers = Integer.parseInt(tmp[1]);
        		  
        	  }
          }
        
          if (workers > 0)
          {
        	  System.out.println("Rate "+rate);
        	  synchronized(model)
        	  {
        	  model.addValue(time, rate, workers, methodName);
        	  }
          }
        }
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
