package gridcomp.manager.beans;


import java.beans.PropertyChangeSupport;
import gridcomp.manager.AbstractAutonomicManager;

public class CounterBean extends AbstractQoSItemBean<Long> {

	long num=0;
	private String interfaceName;
	private final PropertyChangeSupport changes = new PropertyChangeSupport( this );
	
	public CounterBean(AbstractAutonomicManager autonomicManager, long i) {
		super.manager = autonomicManager;
		num= i;
	}

	@Override
	public String getMonitoringInteface() {
		return interfaceName;
	}

	@Override
	public Long getValue() {
		return num;
	}

	@Override
	public void setMonitoringInteface(String s) {
		interfaceName = s;
	}
	public void reset()
	{
		long oldValue = num;
		num = 0L;
		changes.firePropertyChange("value", oldValue, num);
	}
	public void incValue()
	{
		if (num > Long.MAX_VALUE-2)
			num = 0;
	
		long oldValue = num;
		++num;
		changes.firePropertyChange("value", oldValue, num);
		
	}

	@Override
	public void setValue(Long item) {
		num = item;
	}

}
