package gridcomp.manager.gui;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.net.ServerSocketFactory;

public class ManagerMonitorFile implements Observer {
	private ManagerMonitorModel model;
	private String monitorFile;
	private long value = -1;
  public ManagerMonitorFile(ManagerMonitorModel m, String monitorFile)
	{
		this.model = m;
		this.monitorFile = monitorFile;
	  //  update(null,null);
		DataFileWatchdog dog = new DataFileWatchdog(monitorFile);
	    dog.addObserver(this);
	    
	}
public void update(Observable o, Object arg) {
	try {
	FileInputStream fin = new FileInputStream(new File(monitorFile));
	System.err.println("Reading file... "+monitorFile);
	parse(fin);
	fin.close();
	} catch(IOException e) {
		e.printStackTrace();
	};
}
public void parse(InputStream is) throws IOException
{
    	  BufferedReader br = new BufferedReader(new InputStreamReader(is, "US-ASCII"));
          String line = null;
          int workers = 0;
          long time = 0;
          double rate = 0;
          String methodName = "";
       
          while ((line = br.readLine()) != null) {
            System.out.println(line);
          	String[] values = line.split("#");
            int i = 0;
            for (String value: values)
            {
          	  String[] tmp = value.split(":");
          	  if (tmp.length == 2)
          	  {
          		  if (tmp[0].trim().equals("method"))
          			  methodName = tmp[1];
          		  if (tmp[0].trim().equals("time"))
          			  time = Long.parseLong(tmp[1]);
          		  if (tmp[0].trim().equals("rate"))
          			  rate = Double.parseDouble(tmp[1]);
          		  if (tmp[0].trim().equals("workers"))
          			  workers = Integer.parseInt(tmp[1]);
          		  
          	  }
            }
          
            if (workers > 0)
            {
          	  System.out.println("Rate "+rate);
          	  model.updateModel(time, rate, workers, methodName);
            }
          }
}
}

