package gridcomp.manager.gui;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;
import java.util.logging.Logger;

public class ManagerMonitorModelImpl implements ManagerMonitorModel {

	private Vector<ManagerMonitorListener> listener = new Vector<ManagerMonitorListener>();
	private HashMap<Long, Double> rateMap = new HashMap<Long, Double >();
	private HashMap<Long, Integer> workerMap  = new HashMap<Long, Integer>();
	private Logger logger = Logger.getLogger("MonitorModel");
	private long value = 0;
	private boolean firstTime = true;
	public void addModelListener(ManagerMonitorListener l) {
		System.out.println("AddListener");
		listener.add(l);

	}

	public void addValue(long time, double value, int workers, String s) {
	    if (firstTime)
		{
		    rateMap.put(0L,0.0);
		    
		}
		rateMap.put(time, value);
		workerMap.put(time, workers);
		logger.info("Time "+ time +" Rate "+value+" Workers "+ workers);
		ManagerMonitorEvent ev = new ManagerMonitorEvent(this, time, value, workers,s);
		for (ManagerMonitorListener l: listener)
		{
			l.update(ev);
		}
	}

	public void clear() {
		rateMap.clear();
		workerMap.clear();
	}

	public void removeModelListener(ManagerMonitorListener l) {
		this.listener.remove(l);

	}

	public void removeValue(long time) {
		
		rateMap.remove(time);
		workerMap.remove(time);

	}

	public double[][] getRateDataSet() {
		int size = rateMap.size();
		double [][] dataset = new double[size][size];
		Set<Long> set = rateMap.keySet();
		Iterator<Long> it = set.iterator();
		int i=0;
		int j=0;
		while (it.hasNext())
		{
			Long l = it.next();
			if ((i<size) && (j<size))
				dataset[i][j] = l.longValue();
			++j;
			if ((i < size)&& (j<size))
				dataset[i][j] = rateMap.get(l).doubleValue();
			++i;
		}
		return dataset;
	}

	public double[][] getWorkerDataSet() {
		// TODO Auto-generated method stub
		return null;
	}

	public void updateModel(long time, double rate, int workers, String methodName) {
		ManagerMonitorEvent ev = null;
		
		if (firstTime)
		{
			value = time;
			rateMap.put(0L,rate);
			workerMap.put(0L, workers);
			logger.info("Time "+ 0 +" Rate "+rate+" Workers "+ workers);
			ev = new ManagerMonitorEvent(this, 0L, rate, workers, methodName);
			firstTime = false;
		} else {
			long actual = (time - value) / 1000;
			if (!rateMap.containsKey(actual))
			{
			rateMap.put(actual,rate);
			workerMap.put(actual, workers);
			logger.info("Time "+ actual +" Rate "+rate+" Workers "+ workers);
			ev = new ManagerMonitorEvent(this, actual, rate, workers, methodName);
		    for (ManagerMonitorListener l: listener)
			{
				System.out.println("Sending event!");
				l.update(ev);
			}
			}
		}
		     
	}

}
