package gridcomp.manager.gui;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Vector;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.net.ServerSocketFactory;

public class ManagerMonitorServer {
	private static final int PORT_NUM = 8000;
	private ServerSocket serverSocket = null;
	private ManagerMonitorModel model;
	private ExecutorService tp = Executors.newFixedThreadPool(5);
	private Socket socket = null;
  public ManagerMonitorServer(ManagerMonitorModel m)
	{
	  		this.model = m;
		    ServerSocketFactory serverSocketFactory =
		      ServerSocketFactory.getDefault();
		    try {
		      serverSocket =
		        serverSocketFactory.createServerSocket(PORT_NUM);
		  	  System.out.printf("ManagerMonitorServer running on port: %s%n", PORT_NUM);
			
		      socket = serverSocket.accept();
		      tp.submit(new RequestHandler(socket,model));
		       
		    } catch (IOException ignored) {
		      System.err.println("Unable to create server");
		      System.exit(-1);
		    }
		    
	}
}

