package gridcomp.manager.gui;

import javax.swing.SwingUtilities;

import org.jfree.data.DomainOrder;
import org.jfree.data.xy.AbstractXYDataset;

public class RateXYDataset extends AbstractXYDataset {
	double[] xValues_ = new double[1];
	double[] yValues_ = new double[1];
	double[] xPerformance = new double[1];
	double[] yPerformance = new double[1];
    double defaultValue = 3.0;
    public RateXYDataset(double defaultContractRate) {
		xValues_[0] = 0.0;
		yValues_[0] = 0.0;
		defaultValue = defaultContractRate;
		xPerformance[0] = defaultValue;
		yPerformance[0] = defaultValue;
	
	}

	public double[] getXValues() {
		return xValues_;
	}

	public double[] getYValues() {
		return yValues_;
	}

	public void updateDataSet(double[] xValues, double[] yValues) {
		xValues_ = xValues;
		yValues_ = yValues;
		xPerformance = new double[xValues.length];
		yPerformance = new double[yValues.length];
		System.arraycopy(xValues_, 0, xPerformance, 0, xValues_.length);
		for (int i = 0; i < xValues_.length; ++ i)
		{
			yPerformance[i] = defaultValue;
		}
		fireDatasetChanged();
	}

	public DomainOrder getDomainOrder() {
		return DomainOrder.ASCENDING;
	}

	public double getXValue(int series, int item) {
		if (series == 0)
			return xValues_[item];
		 return xPerformance[item];
	}

	public double getYValue(int series, int item) {
		if (series == 0)
			return yValues_[item];
		
		return yPerformance[item];

	}

	public int getSeriesCount() {
		return 2;
	}

	public Comparable getSeriesKey(int series) {
		if (series == 0)
			return "Throughtput";
		return "Performance Contract Threasold";
	}

	public Number getX(int series, int item) {
		return new Double(getXValue(series, item));
	}

	public Number getY(int series, int item) {
		return new Double(getYValue(series, item));
	}

	public int getItemCount(int series)
    {
    
        return xValues_.length;
    }

	public static RateXYDataset createDataSet(double thresold) {
		return new RateXYDataset(thresold);
	}

}
