#include "utils.h"
#include "optparse.h"
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>
#include <math.h>
#define MAX_ARRAY_SIZE 8192*4

void fill_array(double** array, size_t array_len)
{
	double* tmp_array = *array;
    size_t i;
	for (i = 0; i < array_len; ++i)
	{
	tmp_array[i] = random_number();
	}
}
double jump_array(double* array, size_t max_len, int pos, double* max_value) {
	
	if (pos < max_len) {
		*max_value = (*max_value>array[pos]) ? *max_value : array[pos];
	} else
	{
		*max_value = (*max_value>array[0]) ? *max_value : array[0];
	}
	return *max_value;
}
int delay(long delayTime, double* array) {
	struct timeval time;
	struct timeval start;
	struct timeval end;

	double d = 0;
	int i;
	long int value;
	double max_value = 0.0;
	if (gettimeofday(&time, NULL)<0)
		return -1;
	gettimeofday(&start, NULL);
	while (!time_elapsed(delayTime, &time)) {
		for (i = 0; i < INT_MAX; ++i) {

			d+=sin(cos(sqrt(d)))+d;
			d = random_number()+jump_array(array,MAX_ARRAY_SIZE,i*512,&max_value);
			gettimeofday(&end, NULL);
			value = end.tv_sec - start.tv_sec;
			if (value > delayTime)
			{
				fprintf(stdout,"Time elapsed %ld\n", value);
				return 0;
			}
		}
		
	}
	return 0;
}

void stress_cpu() {
	
	__asm__("finit\n\t"
			"pushl %ebp\n\t"				
			"movl %esp, %ebp\n\t"
			"andl $-32, %ebp\n\t"
			"subl $96, %esp\n\t"
			"fldl half\n\t"
			"fstpl -24(%ebp)\n\t"
			"fldl one\n\t"
			"fstl -16(%ebp)\n\t"
			"fld %st\n\t"
			"fld %st\n\t"
			"after_check:\n\t"
			"xorl %eax, %eax\n\t"
			"movl %eax, %ebx\n\t"
			"movl $200000000, %ecx\n\t"
			".align 32, 0x90\n\t"
			"crunch:\n\t"
			"fmull -24(%ebp)\n\t"
			"fxch %st(1)\n\t"
			"faddl -16(%ebp)\n\t"
			"fxch %st(2)\n\t"
			"fmull -24(%ebp)\n\t"
			"fxch %st(1)\n\t"
			"faddl -16(%ebp)\n\t"
			"fxch %st(2)\n\t"
			"fmull -24(%ebp)\n\t"
			"fxch %st(1)\n\t"
			"faddl -16(%ebp)\n\t"
			"fxch %st(2)\n\t"
			"fmull -24(%ebp)\n\t"
			"fxch %st(1)\n\t"
			"faddl -16(%ebp)\n\t"
			"fxch %st(2)\n\t"
			"fmull -24(%ebp)\n\t"
			"fxch %st(1)\n\t"
			"faddl -16(%ebp)\n\t"
			"fxch %st(2)\n\t"
			"fmull -24(%ebp)\n\t"
			"fxch %st(1)\n\t"
			"faddl -16(%ebp)\n\t"
			"fxch %st(2)\n\t"
			"fmull -24(%ebp)\n\t"
			"fxch %st(1)\n\t"
			"faddl -16(%ebp)\n\t"
			"fxch %st(2)\n\t"
			"fmull -24(%ebp)\n\t"
			"fxch %st(1)\n\t"
			"faddl -16(%ebp)\n\t"
			"fxch %st(2)\n\t"
			"decl %ecx\n\t"
			"jnz crunch\n\t"
			"addl $96, %esp\n\t"
			"popl %ebp\n\t"
			"movl $1, %eax\n\t"
			"int $0x80\n\t"				
			".align 32,0\n\t"
			"half:   .long 0xffffffff,0x3fdfffff\n\t"
			"one:    .long 0xffffffff,0x3fefffff\n\t"
);
}
int delay_stress(long delayTime) {
	struct timeval time;
	struct timeval start;
	struct timeval end;

	if (gettimeofday(&time, NULL)<0)
		return -1;
	gettimeofday(&start, NULL);
	while (!time_elapsed(delayTime,&time)) {
		fprintf(stdout,"Calling Stress CPU");
		stress_cpu();
		long value;
		gettimeofday(&end, NULL);
		value = end.tv_sec - start.tv_sec;
		if (value > delayTime)
			{
					fprintf(stdout,"Time elapsed %ld\n", value);
					return 0;
				}
		}
return 0;
}

int main(int argc, char** argv) {

	opt_flags myflags;

	myflags.delay_time = 0;
	myflags.really_stress = 0;
	
	opt_values values;

	values = opt_assign(argc, argv, &myflags);
    
	if (myflags.delay_time == 0)
		opt_usage();
	fprintf(stderr,"Executing with following options:\n");
	fprintf(stderr,"DelayTime -->%ld\n",values.delaytime);
	fprintf(stderr,"CPU Burn mode-->%d\n", values.stress);
	if (daemonize()<0)
	{
		fprintf(stderr,"Cannot became daemon");
	}
	
	
	if (myflags.really_stress>0) {
		printf("Needed really stress");
		delay_stress(values.delaytime);

	} else {

		double* array = (double*) malloc(MAX_ARRAY_SIZE*sizeof(double));
		if (array!=NULL) {
			fill_array(&array, MAX_ARRAY_SIZE);
		}

		delay(values.delaytime, array);
		if (array!=NULL)
			free(array);
	}
return 0;
}
