#include <unistd.h>
#include <signal.h>
#include <sys/resource.h>
#include <sys/time.h>
#include <time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>

int daemonize (void)
{
  pid_t pid;
  struct rlimit rl;
  long max_open;
  int fd;
  struct sigaction act[1];
  /* obtain max file descriptors */
  if (getrlimit (RLIMIT_NOFILE, &rl) < 0)
    return 0;
  max_open = rl.rlim_max;
  
  if ((pid = fork ()) == -1)
    return 0;
  /* parent exit */
  if (pid)
    exit (EXIT_SUCCESS);
  setsid ();
  /* ignore signals */
  act->sa_handler = SIG_IGN;
  sigemptyset (&act->sa_mask);
  act->sa_flags = 0;
  if (sigaction (SIGHUP, act, NULL) == -1)
    return 0;
    /* fork again */
  if ((pid = fork ()) == -1)
    return 0;
    /* parent exit again */
  if (pid)
    exit (EXIT_SUCCESS);
    /* change root dir */
  if (chdir ("/") == -1)
    return 0;
  umask (0);
  /* close all file descriptors */
  for (fd = 0; fd < max_open; ++fd)
    {
      close (fd);
    }
  act->sa_handler = SIG_DFL;
  sigemptyset (&act->sa_mask);
  act->sa_flags = 0;
  if (sigaction (SIGHUP, act, NULL) == -1)
    return 0;

  fprintf(stdout, "Starting CPUStress daemon application");
  return 1;
}
/* 
 * long time - time to be elapsed
 * struct timeval lasttime - first time to count.
 */
int time_elapsed(long time, struct timeval* lasttime)
{
	  struct timeval actualtime;
	  struct timeval endtime;
	  
	  endtime.tv_sec = lasttime->tv_sec + time;
	  endtime.tv_usec = 0;
	  
	
	  if (gettimeofday (&actualtime, NULL) < 0)
	    return 1;
	  int at = actualtime.tv_sec;
	  int et = endtime.tv_sec;
	  fprintf(stdout,"Actual Time = %d\n", at);
	  fprintf(stdout,"Deadline Time = %d\n", et);
	  
	  if (at>et)
	  {
		 fprintf(stdout,"Time %ld elapsed", time);
	    return 1;
	  }
	  else
	      return 0;
	
}
double random_number()
{
	 double random_number;
	 srandom(time(0) * getpid());

	 random_number = (float) random() / (float) 0x7fffffff;
	 return (random_number*100);
}
